import { computed, openBlock, createElementBlock, unref, createElementVNode, toDisplayString, createCommentVNode, normalizeClass, withDirectives, isRef, vModelCheckbox, Fragment, renderList, resolveDirective, vModelText, renderSlot, vShow, defineComponent, inject, ref, onMounted, onUnmounted, createVNode, toRef, watchEffect, shallowRef, watch, h, provide, Teleport, Transition, isVNode, normalizeStyle } from "vue";
const _hoisted_1$9 = { class: "tuxedo-input-field-group" };
const _hoisted_2$9 = ["for"];
const _hoisted_3$9 = { key: 0 };
const _hoisted_4$9 = {
  key: 1,
  class: "input-group percent-group"
};
const _hoisted_5$7 = ["id", "value"];
const _hoisted_6$5 = /* @__PURE__ */ createElementVNode("span", null, "%", -1);
const _hoisted_7$3 = {
  key: 2,
  class: "input-group"
};
const _hoisted_8$2 = ["type", "id", "value"];
const _hoisted_9$2 = {
  key: 3,
  class: "form-text text-danger"
};
const _hoisted_10$2 = {
  key: 4,
  class: "form-text text-muted"
};
const _sfc_main$8 = {
  __name: "InputField",
  props: {
    type: {
      type: String,
      required: false,
      validator: (value) => {
        return [
          "datetime-local",
          "email",
          "number",
          "password",
          "tel",
          "text",
          "time",
          "url",
          "percentage"
        ].indexOf(value) !== -1;
      }
    },
    label: {
      type: String,
      required: false
    },
    sub: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    help: {
      type: String,
      required: false
    },
    modelValue: {
      type: [String, Number],
      required: false
    },
    error: {
      type: Object,
      required: false
    },
    inputClass: {
      type: String,
      required: false
    },
    autocomplete: {
      type: Boolean,
      required: false,
      default() {
        return true;
      }
    }
  },
  emits: ["update:modelValue"],
  setup(__props) {
    const props = __props;
    const fieldName = computed(() => {
      if (props.autocomplete)
        return props.name;
      return makeID();
    });
    const makeID = () => {
      let result = "";
      const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
      const charLength = chars.length;
      for (let i = 0; i < 8; i++) {
        result += chars.charAt(Math.floor(Math.random() * charLength));
      }
      return "tuxedo=" + result;
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$9, [
        __props.label ? (openBlock(), createElementBlock("label", {
          key: 0,
          for: unref(fieldName)
        }, [
          createElementVNode("span", null, toDisplayString(__props.label), 1),
          __props.sub ? (openBlock(), createElementBlock("small", _hoisted_3$9, toDisplayString(__props.sub), 1)) : createCommentVNode("", true)
        ], 8, _hoisted_2$9)) : createCommentVNode("", true),
        __props.type === "percentage" ? (openBlock(), createElementBlock("div", _hoisted_4$9, [
          createElementVNode("input", {
            type: "number",
            id: unref(fieldName),
            value: __props.modelValue,
            onInput: _cache[0] || (_cache[0] = ($event) => _ctx.$emit("update:modelValue", $event.target.value))
          }, null, 40, _hoisted_5$7),
          _hoisted_6$5
        ])) : (openBlock(), createElementBlock("div", _hoisted_7$3, [
          createElementVNode("input", {
            type: __props.type || "text",
            class: normalizeClass(__props.inputClass),
            id: unref(fieldName),
            value: __props.modelValue,
            onInput: _cache[1] || (_cache[1] = ($event) => _ctx.$emit("update:modelValue", $event.target.value))
          }, null, 42, _hoisted_8$2)
        ])),
        __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_9$2, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_10$2, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
      ]);
    };
  }
};
const _hoisted_1$8 = { class: "tuxedo-input-field-group" };
const _hoisted_2$8 = ["for"];
const _hoisted_3$8 = { key: 0 };
const _hoisted_4$8 = { class: "input-group" };
const _hoisted_5$6 = ["name", "id", "maxlength", "value"];
const _hoisted_6$4 = {
  key: 1,
  class: "form-text text-danger"
};
const _hoisted_7$2 = {
  key: 2,
  class: "form-text text-muted"
};
const _sfc_main$7 = {
  __name: "TextField",
  props: {
    label: {
      type: String,
      required: false
    },
    sub: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    help: {
      type: String,
      required: false
    },
    modelValue: {
      type: [String, Number],
      required: false
    },
    error: {
      type: Object,
      required: false
    },
    inputClass: {
      type: String,
      required: false
    },
    maxLength: {
      type: Number,
      required: false
    }
  },
  emits: ["update:modelValue"],
  setup(__props) {
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$8, [
        __props.label ? (openBlock(), createElementBlock("label", {
          key: 0,
          for: __props.name
        }, [
          createElementVNode("span", null, toDisplayString(__props.label), 1),
          __props.sub ? (openBlock(), createElementBlock("small", _hoisted_3$8, toDisplayString(__props.sub), 1)) : createCommentVNode("", true)
        ], 8, _hoisted_2$8)) : createCommentVNode("", true),
        createElementVNode("div", _hoisted_4$8, [
          createElementVNode("textarea", {
            name: __props.name,
            id: __props.name,
            maxlength: __props.maxLength,
            value: __props.modelValue,
            onInput: _cache[0] || (_cache[0] = ($event) => _ctx.$emit("update:modelValue", $event.target.value)),
            class: normalizeClass(__props.inputClass)
          }, null, 42, _hoisted_5$6)
        ]),
        __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_6$4, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_7$2, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
      ]);
    };
  }
};
const _hoisted_1$7 = { class: "tuxedo-input-field-group" };
const _hoisted_2$7 = { class: "tuxedo-switch" };
const _hoisted_3$7 = ["id"];
const _hoisted_4$7 = ["for"];
const _hoisted_5$5 = {
  key: 0,
  class: "form-text text-danger"
};
const _hoisted_6$3 = {
  key: 1,
  class: "form-text text-muted"
};
const _sfc_main$6 = {
  __name: "SwitchField",
  props: {
    label: {
      type: String,
      required: true
    },
    name: {
      type: String,
      required: true
    },
    help: {
      type: String,
      required: false
    },
    modelValue: {
      type: Boolean,
      required: false
    },
    error: {
      type: Object,
      required: false
    }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    let inputValue = computed({
      get() {
        return props.modelValue;
      },
      set(val) {
        emit("update:modelValue", val);
      }
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$7, [
        createElementVNode("div", _hoisted_2$7, [
          withDirectives(createElementVNode("input", {
            class: "form-check-input",
            type: "checkbox",
            id: __props.name,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => isRef(inputValue) ? inputValue.value = $event : inputValue = $event)
          }, null, 8, _hoisted_3$7), [
            [vModelCheckbox, unref(inputValue)]
          ]),
          createElementVNode("label", {
            class: "form-check-label",
            for: __props.name
          }, toDisplayString(__props.label), 9, _hoisted_4$7)
        ]),
        __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_5$5, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_6$3, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
      ]);
    };
  }
};
const _hoisted_1$6 = { class: "tuxedo-input-field-group" };
const _hoisted_2$6 = ["for"];
const _hoisted_3$6 = { style: { "margin-bottom": "0.5rem" } };
const _hoisted_4$6 = {
  key: 0,
  class: "form-text text-danger"
};
const _hoisted_5$4 = {
  key: 1,
  class: "form-text text-muted"
};
const _hoisted_6$2 = { class: "radio-slider" };
const _hoisted_7$1 = /* @__PURE__ */ createElementVNode("span", { class: "connector" }, null, -1);
const _hoisted_8$1 = ["id", "name", "value", "checked"];
const _hoisted_9$1 = /* @__PURE__ */ createElementVNode("span", { class: "checked" }, null, -1);
const _hoisted_10$1 = ["for"];
const _hoisted_11$1 = { class: "radio-label" };
const _hoisted_12$1 = {
  key: 0,
  class: "merged-background"
};
const _sfc_main$5 = {
  __name: "RadioSlider",
  props: {
    label: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    help: {
      type: String,
      required: false
    },
    modelValue: {
      type: [String, Number],
      required: false
    },
    options: {
      type: Object,
      required: true
    },
    merge: {
      type: Boolean,
      required: false
    },
    error: {
      type: Object,
      required: false
    }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const updateValue = (val) => {
      emit("update:modelValue", val);
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$6, [
        __props.label ? (openBlock(), createElementBlock("label", {
          key: 0,
          for: __props.name
        }, toDisplayString(__props.label), 9, _hoisted_2$6)) : createCommentVNode("", true),
        createElementVNode("div", _hoisted_3$6, [
          __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_4$6, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_5$4, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
        ]),
        createElementVNode("div", _hoisted_6$2, [
          createElementVNode("ul", {
            class: normalizeClass(__props.merge ? "radio-merge" : "")
          }, [
            (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (option, key) => {
              return openBlock(), createElementBlock("li", {
                class: "note-slider",
                key
              }, [
                _hoisted_7$1,
                createElementVNode("input", {
                  type: "radio",
                  id: "r" + key + "-" + __props.name,
                  name: __props.name,
                  value: key,
                  onClick: _cache[0] || (_cache[0] = ($event) => updateValue($event.target.value)),
                  checked: __props.modelValue == key || !__props.modelValue && key == 0
                }, null, 8, _hoisted_8$1),
                _hoisted_9$1,
                createElementVNode("label", {
                  for: "r" + key + "-" + __props.name
                }, null, 8, _hoisted_10$1),
                createElementVNode("span", _hoisted_11$1, toDisplayString(option), 1)
              ]);
            }), 128))
          ], 2),
          __props.merge ? (openBlock(), createElementBlock("div", _hoisted_12$1)) : createCommentVNode("", true)
        ])
      ]);
    };
  }
};
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
var vClickOutside_umd = { exports: {} };
(function(module, exports) {
  !function(e, n) {
    module.exports = n();
  }(commonjsGlobal, function() {
    var e = "__v-click-outside", n = typeof window != "undefined", t = typeof navigator != "undefined", r = n && ("ontouchstart" in window || t && navigator.msMaxTouchPoints > 0) ? ["touchstart"] : ["click"], i = function(e2) {
      var n2 = e2.event, t2 = e2.handler;
      (0, e2.middleware)(n2) && t2(n2);
    }, a2 = function(n2, t2) {
      var a3 = function(e2) {
        var n3 = typeof e2 == "function";
        if (!n3 && typeof e2 != "object")
          throw new Error("v-click-outside: Binding value must be a function or an object");
        return { handler: n3 ? e2 : e2.handler, middleware: e2.middleware || function(e3) {
          return e3;
        }, events: e2.events || r, isActive: !(e2.isActive === false), detectIframe: !(e2.detectIframe === false), capture: Boolean(e2.capture) };
      }(t2.value), o2 = a3.handler, d3 = a3.middleware, c = a3.detectIframe, u = a3.capture;
      if (a3.isActive) {
        if (n2[e] = a3.events.map(function(e2) {
          return { event: e2, srcTarget: document.documentElement, handler: function(e3) {
            return function(e4) {
              var n3 = e4.el, t3 = e4.event, r2 = e4.handler, a4 = e4.middleware, o3 = t3.path || t3.composedPath && t3.composedPath();
              (o3 ? o3.indexOf(n3) < 0 : !n3.contains(t3.target)) && i({ event: t3, handler: r2, middleware: a4 });
            }({ el: n2, event: e3, handler: o2, middleware: d3 });
          }, capture: u };
        }), c) {
          var l = { event: "blur", srcTarget: window, handler: function(e2) {
            return function(e3) {
              var n3 = e3.el, t3 = e3.event, r2 = e3.handler, a4 = e3.middleware;
              setTimeout(function() {
                var e4 = document.activeElement;
                e4 && e4.tagName === "IFRAME" && !n3.contains(e4) && i({ event: t3, handler: r2, middleware: a4 });
              }, 0);
            }({ el: n2, event: e2, handler: o2, middleware: d3 });
          }, capture: u };
          n2[e] = [].concat(n2[e], [l]);
        }
        n2[e].forEach(function(t3) {
          var r2 = t3.event, i2 = t3.srcTarget, a4 = t3.handler;
          return setTimeout(function() {
            n2[e] && i2.addEventListener(r2, a4, u);
          }, 0);
        });
      }
    }, o = function(n2) {
      (n2[e] || []).forEach(function(e2) {
        return e2.srcTarget.removeEventListener(e2.event, e2.handler, e2.capture);
      }), delete n2[e];
    }, d2 = n ? { beforeMount: a2, updated: function(e2, n2) {
      var t2 = n2.value, r2 = n2.oldValue;
      JSON.stringify(t2) !== JSON.stringify(r2) && (o(e2), a2(e2, { value: t2 }));
    }, unmounted: o } : {};
    return { install: function(e2) {
      e2.directive("click-outside", d2);
    }, directive: d2 };
  });
})(vClickOutside_umd);
var vClickOutside = vClickOutside_umd.exports;
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _sfc_main$4 = {
  name: "SelectField",
  directives: {
    clickOutside: vClickOutside.directive
  },
  props: {
    label: {
      type: String,
      required: false
    },
    sub: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: false
    },
    help: {
      type: String,
      required: false
    },
    modelValue: {
      type: [String, Number, Object],
      required: false
    },
    error: {
      type: Object,
      required: false
    },
    options: {
      type: Array,
      required: true
    },
    multi: {
      type: Boolean,
      default: false,
      required: false
    },
    insistLabel: {
      type: String,
      default: "label",
      required: false
    },
    insistDisplay: {
      type: String,
      required: false
    },
    insistSelectAll: {
      type: String,
      default: "Select All",
      required: false
    },
    insistUnselectAll: {
      type: String,
      default: "Unselect All",
      required: false
    },
    insistReturn: {
      type: String,
      default: "object",
      required: false
    },
    default: {
      type: [String, Number, Array],
      required: false
    },
    loading: {
      type: Boolean,
      required: false
    },
    inputClass: {
      type: String,
      required: false
    }
  },
  data() {
    return {
      searchPhrase: null,
      pickerActive: false,
      objectsSelected: [],
      inputReadOnly: true,
      scrollEvent: null
    };
  },
  computed: {
    inputValue: {
      get() {
        if (this.objectsSelected[0]) {
          return this.resolve(this.insistLabel, this.objectsSelected[0]);
        } else if (this.modelValue) {
          if (this.insistReturn === "object")
            return this.resolve(this.insistLabel, this.modelValue[0]);
          else {
            const obj = this.options.find((o) => o[this.insistReturn] == this.modelValue);
            if (obj) {
              this.objectsSelected = [JSON.parse(JSON.stringify(obj))];
              return this.resolve(this.insistLabel, obj);
            }
          }
        }
        return "";
      },
      set(val) {
        this.$emit("input", val);
      }
    },
    selectDisplay: {
      get() {
        if (this.pickerActive) {
          return this.searchPhrase;
        } else if (this.insistDisplay) {
          return this.insistDisplay;
        } else {
          if (this.multi) {
            let string = [];
            let others = 0;
            this.objectsSelected.forEach((o) => {
              if (string.length < 3)
                string.push(this.resolve(this.insistLabel, o));
              else
                others += 1;
            });
            if (others > 0)
              string.push("+" + others);
            return string.join(", ");
          }
          return this.inputValue;
        }
      },
      set(val) {
        this.searchPhrase = val;
      }
    },
    filteredOptions() {
      if (this.searchPhrase) {
        let arr = [];
        this.options.forEach((o) => {
          Object.entries(o).some((p) => {
            let string = JSON.stringify(p[1]).toLowerCase();
            if (string.includes(this.searchPhrase.toLowerCase())) {
              arr.push(o);
              return true;
            }
          });
        });
        this.resizeSelectionBox();
        return JSON.parse(JSON.stringify(arr));
      }
      this.resizeSelectionBox();
      return JSON.parse(JSON.stringify(this.options));
    },
    fieldID() {
      if (this.id)
        return this.id;
      let result = "";
      const characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
      const charactersLength = characters.length;
      for (let i = 0; i < 6; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
      }
      return this.name + "_" + result;
    }
  },
  mounted() {
    setTimeout(() => {
      this.assignCurrentSelection();
    }, 150);
  },
  created() {
    window.addEventListener("resize", this.resizeSelectionBox);
  },
  destroyed() {
    window.removeEventListener("resize", this.resizeSelectionBox);
  },
  watch: {
    pickerActive(val) {
      const body = document.getElementsByTagName("body")[0];
      if (window.innerWidth < 768) {
        if (val)
          body.style.overflow = "hidden";
        else
          body.style.overflow = null;
      } else {
        window.addEventListener("scroll", this.resizeSelectionBox);
      }
      if (!val) {
        window.removeEventListener("scroll", this.resizeSelectionBox, true);
      }
      this.resizeSelectionBox();
    },
    options() {
      this.assignCurrentSelection();
    }
  },
  methods: {
    assignCurrentSelection() {
      if (this.multi && this.modelValue) {
        let selection = [];
        this.options.forEach((o) => {
          if (this.insistReturn === "object") {
            this.modelValue.forEach((v) => {
              if (JSON.stringify(v) === JSON.stringify(o)) {
                selection.push(JSON.parse(JSON.stringify(o)));
              }
            });
          } else {
            if (this.modelValue.includes(o[this.insistReturn])) {
              selection.push(JSON.parse(JSON.stringify(o)));
            }
          }
        });
        selection = [...new Set(selection)];
        this.objectsSelected = selection;
      } else if (this.default && !this.modelValue) {
        this.objectsSelected = this.default;
      } else if (!this.modelValue) {
        this.objectsSelected = [];
      }
      this.$emit("input", this.determineValue());
    },
    selectAll() {
      this.objectsSelected = [];
      this.filteredOptions.forEach((o) => {
        this.objectsSelected.push(o);
      });
      if (this.insistReturn === "object")
        this.inputValue = this.objectsSelected;
      else {
        let arr = [];
        this.objectsSelected.forEach((os) => {
          arr.push(os[this.insistReturn]);
        });
        this.inputValue = arr;
      }
    },
    unselectAll() {
      this.objectsSelected = [];
      this.inputValue = [];
    },
    selected(o) {
      return this.objectsSelected && this.objectsSelected.findIndex((os) => JSON.stringify(os) === JSON.stringify(o)) >= 0;
    },
    select(o) {
      if (this.multi) {
        const key = this.objectsSelected.findIndex((os) => JSON.stringify(os) === JSON.stringify(o));
        if (key === -1)
          this.objectsSelected.push(o);
        else
          this.objectsSelected.splice(key, 1);
      } else {
        this.objectsSelected = [o];
        this.pickerActive = false;
      }
      this.inputValue = this.determineValue();
    },
    determineValue() {
      if (this.multi) {
        if (this.insistReturn === "object")
          return this.objectsSelected;
        else {
          let arr = [];
          this.objectsSelected.forEach((os) => {
            arr.push(os[this.insistReturn]);
          });
          return arr;
        }
      } else if (this.objectsSelected[0]) {
        if (this.insistReturn === "object")
          return this.objectsSelected[0];
        else
          return this.objectsSelected[0][this.insistReturn];
      }
    },
    closeSelector() {
      this.pickerActive = false;
    },
    resizeSelectionBox(e) {
      setTimeout(() => {
        const windowHeight = window.innerHeight;
        let maxHeight = windowHeight - 80;
        const options = this.$el.getElementsByClassName("option");
        let optionsHeight = 30;
        let singleHeight = 50;
        let inputHeight = 38;
        let spaceAbove = 100;
        let spaceBelow = 200;
        const target = document.getElementById(this.id);
        const element = target ? target.parentElement : void 0;
        const container = this.$el.getElementsByClassName("select-options")[0];
        if (options[0]) {
          singleHeight = options[0].scrollHeight;
        }
        for (const o of options) {
          optionsHeight += o.scrollHeight;
        }
        if (window.innerWidth >= 768) {
          this.inputReadOnly = false;
          if (element) {
            inputHeight = element.getBoundingClientRect().height;
            spaceAbove = element.getBoundingClientRect().top;
            const left = element.getBoundingClientRect().left;
            const width = element.getBoundingClientRect().width;
            spaceBelow = windowHeight - element.getBoundingClientRect().bottom;
            container.style.left = left + "px";
            container.style.width = width + "px";
            maxHeight = Math.max(spaceAbove, spaceBelow);
            maxHeight = Math.min(maxHeight, 300);
          }
          singleHeight += 24;
        } else {
          this.inputReadOnly = true;
          optionsHeight += 115;
          singleHeight += 105;
          container.style.top = "auto";
          container.style.left = "0";
          container.style.width = "100%";
          container.style.bottom = "0";
          container.style.height = "auto";
          maxHeight = windowHeight - 80;
        }
        optionsHeight = Math.max(optionsHeight, singleHeight);
        const height = Math.min(maxHeight, optionsHeight);
        container.style.height = height + "px";
        if (window.innerWidth >= 768) {
          if (element) {
            if (spaceBelow < 300 && spaceAbove > spaceBelow) {
              container.style.top = "auto";
              container.style.bottom = spaceBelow + inputHeight + "px";
            } else {
              container.style.top = spaceAbove + inputHeight + "px";
              container.style.bottom = "auto";
            }
          }
        }
      }, 5);
    },
    resolve(path, obj) {
      const val = path.split(".").reduce(function(prev, curr) {
        return prev ? prev[curr] : null;
      }, obj || self);
      return val && val.length > 0 ? val : "&nbsp;";
    }
  }
};
const _hoisted_1$5 = { class: "tuxedo-input-field-group" };
const _hoisted_2$5 = ["for"];
const _hoisted_3$5 = { key: 0 };
const _hoisted_4$5 = { class: "input-group select-group" };
const _hoisted_5$3 = ["id", "name", "readonly"];
const _hoisted_6$1 = { class: "tuxedo-input-action" };
const _hoisted_7 = /* @__PURE__ */ createElementVNode("path", {
  "fill-rule": "evenodd",
  d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"
}, null, -1);
const _hoisted_8 = [
  _hoisted_7
];
const _hoisted_9 = { class: "select-picker" };
const _hoisted_10 = { class: "select-options" };
const _hoisted_11 = { class: "tuxedo-mobile-select-options" };
const _hoisted_12 = {
  key: 0,
  class: "select-grow-2"
};
const _hoisted_13 = { class: "select-grow-1" };
const _hoisted_14 = /* @__PURE__ */ createElementVNode("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  fill: "currentColor",
  viewBox: "0 0 16 16"
}, [
  /* @__PURE__ */ createElementVNode("path", {
    "fill-rule": "evenodd",
    d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"
  })
], -1);
const _hoisted_15 = [
  _hoisted_14
];
const _hoisted_16 = {
  key: 1,
  class: "select-grow-2"
};
const _hoisted_17 = { class: "options" };
const _hoisted_18 = {
  key: 0,
  class: "option multi-select-options"
};
const _hoisted_19 = ["onClick"];
const _hoisted_20 = { class: "label" };
const _hoisted_21 = /* @__PURE__ */ createElementVNode("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 512 512",
  width: "24",
  height: "16"
}, [
  /* @__PURE__ */ createElementVNode("path", { d: "M0 256C0 114.6 114.6 0 256 0C397.4 0 512 114.6 512 256C512 397.4 397.4 512 256 512C114.6 512 0 397.4 0 256zM371.8 211.8C382.7 200.9 382.7 183.1 371.8 172.2C360.9 161.3 343.1 161.3 332.2 172.2L224 280.4L179.8 236.2C168.9 225.3 151.1 225.3 140.2 236.2C129.3 247.1 129.3 264.9 140.2 275.8L204.2 339.8C215.1 350.7 232.9 350.7 243.8 339.8L371.8 211.8z" })
], -1);
const _hoisted_22 = { class: "tuxedo-input-search" };
const _hoisted_23 = ["name"];
const _hoisted_24 = /* @__PURE__ */ createElementVNode("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "30",
  height: "16",
  fill: "currentColor",
  viewBox: "0 0 16 16",
  class: "search-icon"
}, [
  /* @__PURE__ */ createElementVNode("path", { d: "M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001c.03.04.062.078.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1.007 1.007 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0z" })
], -1);
const _hoisted_25 = {
  key: 1,
  class: "form-text text-danger"
};
const _hoisted_26 = {
  key: 2,
  class: "form-text text-muted"
};
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _directive_click_outside = resolveDirective("click-outside");
  return openBlock(), createElementBlock("div", _hoisted_1$5, [
    $props.label ? (openBlock(), createElementBlock("label", {
      key: 0,
      for: $options.fieldID
    }, [
      createElementVNode("span", null, toDisplayString($props.label), 1),
      $props.sub ? (openBlock(), createElementBlock("small", _hoisted_3$5, toDisplayString($props.sub), 1)) : createCommentVNode("", true)
    ], 8, _hoisted_2$5)) : createCommentVNode("", true),
    withDirectives((openBlock(), createElementBlock("div", _hoisted_4$5, [
      createElementVNode("div", {
        class: normalizeClass(["tuxedo-input-wrapper clickable", $props.inputClass])
      }, [
        withDirectives(createElementVNode("input", {
          type: "text",
          id: $options.fieldID,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => $options.selectDisplay = $event),
          onClick: _cache[1] || (_cache[1] = ($event) => $data.pickerActive = true),
          name: $options.fieldID,
          class: normalizeClass($props.inputClass),
          autocomplete: "off",
          autocorrect: "off",
          autocapitalize: "none",
          spellcheck: "false",
          readonly: $data.inputReadOnly
        }, null, 10, _hoisted_5$3), [
          [vModelText, $options.selectDisplay]
        ]),
        createElementVNode("div", _hoisted_6$1, [
          renderSlot(_ctx.$slots, "action", {}, () => [
            (openBlock(), createElementBlock("svg", {
              xmlns: "http://www.w3.org/2000/svg",
              width: "16",
              fill: "currentColor",
              viewBox: "0 0 16 16",
              onClick: _cache[2] || (_cache[2] = ($event) => $data.pickerActive = true)
            }, _hoisted_8))
          ])
        ])
      ], 2),
      withDirectives(createElementVNode("div", _hoisted_9, [
        createElementVNode("div", _hoisted_10, [
          createElementVNode("div", _hoisted_11, [
            $props.multi ? (openBlock(), createElementBlock("div", _hoisted_12, [
              createElementVNode("div", {
                class: "select-all-button",
                onClick: _cache[3] || (_cache[3] = (...args) => $options.selectAll && $options.selectAll(...args))
              }, toDisplayString($props.insistSelectAll), 1)
            ])) : createCommentVNode("", true),
            createElementVNode("div", _hoisted_13, [
              createElementVNode("div", {
                class: "select-close-icon",
                onClick: _cache[4] || (_cache[4] = ($event) => $data.pickerActive = false)
              }, _hoisted_15)
            ]),
            $props.multi ? (openBlock(), createElementBlock("div", _hoisted_16, [
              createElementVNode("div", {
                class: "unselect-all-button",
                onClick: _cache[5] || (_cache[5] = (...args) => $options.unselectAll && $options.unselectAll(...args))
              }, toDisplayString($props.insistUnselectAll), 1)
            ])) : createCommentVNode("", true)
          ]),
          createElementVNode("div", _hoisted_17, [
            $props.multi ? (openBlock(), createElementBlock("div", _hoisted_18, [
              createElementVNode("div", {
                class: "select-all-button",
                onClick: _cache[6] || (_cache[6] = (...args) => $options.selectAll && $options.selectAll(...args))
              }, toDisplayString($props.insistSelectAll), 1),
              createElementVNode("div", {
                class: "unselect-all-button",
                onClick: _cache[7] || (_cache[7] = (...args) => $options.unselectAll && $options.unselectAll(...args))
              }, toDisplayString($props.insistUnselectAll), 1)
            ])) : createCommentVNode("", true),
            (openBlock(true), createElementBlock(Fragment, null, renderList($options.filteredOptions, (option, key) => {
              return openBlock(), createElementBlock("div", {
                class: normalizeClass(["option", $options.selected(option) ? "active" : ""]),
                key: $props.name + "Objects" + key,
                onClick: ($event) => $options.select(option)
              }, [
                createElementVNode("div", _hoisted_20, [
                  renderSlot(_ctx.$slots, "label", { option }, () => [
                    createElementVNode("span", null, toDisplayString($options.resolve($props.insistLabel, option)), 1)
                  ]),
                  _hoisted_21
                ]),
                renderSlot(_ctx.$slots, "content", {
                  class: "content",
                  option
                })
              ], 10, _hoisted_19);
            }), 128))
          ]),
          createElementVNode("div", _hoisted_22, [
            withDirectives(createElementVNode("input", {
              type: "search",
              name: $options.fieldID,
              "onUpdate:modelValue": _cache[8] || (_cache[8] = ($event) => $data.searchPhrase = $event),
              autocomplete: "off",
              autocorrect: "off",
              autocapitalize: "off"
            }, null, 8, _hoisted_23), [
              [vModelText, $data.searchPhrase]
            ]),
            _hoisted_24
          ])
        ])
      ], 512), [
        [vShow, $data.pickerActive]
      ])
    ])), [
      [_directive_click_outside, $options.closeSelector]
    ]),
    $props.error && $props.error[$props.name] ? (openBlock(), createElementBlock("small", _hoisted_25, toDisplayString($props.error[$props.name][0]), 1)) : $props.help ? (openBlock(), createElementBlock("small", _hoisted_26, toDisplayString($props.help), 1)) : createCommentVNode("", true)
  ]);
}
var ObjectSelectField = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$2]]);
function isDate(value) {
  return value instanceof Date || Object.prototype.toString.call(value) === "[object Date]";
}
function toDate(value) {
  if (isDate(value)) {
    return new Date(value.getTime());
  }
  if (value == null) {
    return new Date(NaN);
  }
  return new Date(value);
}
function isValidDate$1(value) {
  return isDate(value) && !isNaN(value.getTime());
}
function startOfWeek(value) {
  var firstDayOfWeek = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
  if (!(firstDayOfWeek >= 0 && firstDayOfWeek <= 6)) {
    throw new RangeError("weekStartsOn must be between 0 and 6");
  }
  var date = toDate(value);
  var day = date.getDay();
  var diff = (day + 7 - firstDayOfWeek) % 7;
  date.setDate(date.getDate() - diff);
  date.setHours(0, 0, 0, 0);
  return date;
}
function startOfWeekYear(value) {
  var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$firstDayOfWeek = _ref.firstDayOfWeek, firstDayOfWeek = _ref$firstDayOfWeek === void 0 ? 0 : _ref$firstDayOfWeek, _ref$firstWeekContain = _ref.firstWeekContainsDate, firstWeekContainsDate = _ref$firstWeekContain === void 0 ? 1 : _ref$firstWeekContain;
  if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
    throw new RangeError("firstWeekContainsDate must be between 1 and 7");
  }
  var date = toDate(value);
  var year = date.getFullYear();
  var firstDateOfFirstWeek = new Date(0);
  for (var i = year + 1; i >= year - 1; i--) {
    firstDateOfFirstWeek.setFullYear(i, 0, firstWeekContainsDate);
    firstDateOfFirstWeek.setHours(0, 0, 0, 0);
    firstDateOfFirstWeek = startOfWeek(firstDateOfFirstWeek, firstDayOfWeek);
    if (date.getTime() >= firstDateOfFirstWeek.getTime()) {
      break;
    }
  }
  return firstDateOfFirstWeek;
}
function getWeek(value) {
  var _ref2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref2$firstDayOfWeek = _ref2.firstDayOfWeek, firstDayOfWeek = _ref2$firstDayOfWeek === void 0 ? 0 : _ref2$firstDayOfWeek, _ref2$firstWeekContai = _ref2.firstWeekContainsDate, firstWeekContainsDate = _ref2$firstWeekContai === void 0 ? 1 : _ref2$firstWeekContai;
  var date = toDate(value);
  var firstDateOfThisWeek = startOfWeek(date, firstDayOfWeek);
  var firstDateOfFirstWeek = startOfWeekYear(date, {
    firstDayOfWeek,
    firstWeekContainsDate
  });
  var diff = firstDateOfThisWeek.getTime() - firstDateOfFirstWeek.getTime();
  return Math.round(diff / (7 * 24 * 3600 * 1e3)) + 1;
}
var locale$1 = {
  months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
  monthsShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
  weekdays: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
  weekdaysShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  weekdaysMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
  firstDayOfWeek: 0,
  firstWeekContainsDate: 1
};
var REGEX_FORMAT = /\[([^\]]+)]|YYYY|YY?|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|m{1,2}|s{1,2}|Z{1,2}|S{1,3}|w{1,2}|x|X|a|A/g;
function pad(val) {
  var len = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 2;
  var output = "".concat(Math.abs(val));
  var sign = val < 0 ? "-" : "";
  while (output.length < len) {
    output = "0".concat(output);
  }
  return sign + output;
}
function getOffset(date) {
  return Math.round(date.getTimezoneOffset() / 15) * 15;
}
function formatTimezone(offset) {
  var delimeter = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "";
  var sign = offset > 0 ? "-" : "+";
  var absOffset = Math.abs(offset);
  var hours = Math.floor(absOffset / 60);
  var minutes = absOffset % 60;
  return sign + pad(hours, 2) + delimeter + pad(minutes, 2);
}
var meridiem = function meridiem2(h3, _, isLowercase) {
  var word = h3 < 12 ? "AM" : "PM";
  return isLowercase ? word.toLocaleLowerCase() : word;
};
var formatFlags = {
  Y: function Y(date) {
    var y = date.getFullYear();
    return y <= 9999 ? "".concat(y) : "+".concat(y);
  },
  YY: function YY(date) {
    return pad(date.getFullYear(), 4).substr(2);
  },
  YYYY: function YYYY(date) {
    return pad(date.getFullYear(), 4);
  },
  M: function M(date) {
    return date.getMonth() + 1;
  },
  MM: function MM(date) {
    return pad(date.getMonth() + 1, 2);
  },
  MMM: function MMM(date, locale2) {
    return locale2.monthsShort[date.getMonth()];
  },
  MMMM: function MMMM(date, locale2) {
    return locale2.months[date.getMonth()];
  },
  D: function D(date) {
    return date.getDate();
  },
  DD: function DD(date) {
    return pad(date.getDate(), 2);
  },
  H: function H(date) {
    return date.getHours();
  },
  HH: function HH(date) {
    return pad(date.getHours(), 2);
  },
  h: function h2(date) {
    var hours = date.getHours();
    if (hours === 0) {
      return 12;
    }
    if (hours > 12) {
      return hours % 12;
    }
    return hours;
  },
  hh: function hh() {
    var hours = formatFlags.h.apply(formatFlags, arguments);
    return pad(hours, 2);
  },
  m: function m(date) {
    return date.getMinutes();
  },
  mm: function mm(date) {
    return pad(date.getMinutes(), 2);
  },
  s: function s(date) {
    return date.getSeconds();
  },
  ss: function ss(date) {
    return pad(date.getSeconds(), 2);
  },
  S: function S(date) {
    return Math.floor(date.getMilliseconds() / 100);
  },
  SS: function SS(date) {
    return pad(Math.floor(date.getMilliseconds() / 10), 2);
  },
  SSS: function SSS(date) {
    return pad(date.getMilliseconds(), 3);
  },
  d: function d(date) {
    return date.getDay();
  },
  dd: function dd(date, locale2) {
    return locale2.weekdaysMin[date.getDay()];
  },
  ddd: function ddd(date, locale2) {
    return locale2.weekdaysShort[date.getDay()];
  },
  dddd: function dddd(date, locale2) {
    return locale2.weekdays[date.getDay()];
  },
  A: function A(date, locale2) {
    var meridiemFunc = locale2.meridiem || meridiem;
    return meridiemFunc(date.getHours(), date.getMinutes(), false);
  },
  a: function a(date, locale2) {
    var meridiemFunc = locale2.meridiem || meridiem;
    return meridiemFunc(date.getHours(), date.getMinutes(), true);
  },
  Z: function Z(date) {
    return formatTimezone(getOffset(date), ":");
  },
  ZZ: function ZZ(date) {
    return formatTimezone(getOffset(date));
  },
  X: function X(date) {
    return Math.floor(date.getTime() / 1e3);
  },
  x: function x(date) {
    return date.getTime();
  },
  w: function w(date, locale2) {
    return getWeek(date, {
      firstDayOfWeek: locale2.firstDayOfWeek,
      firstWeekContainsDate: locale2.firstWeekContainsDate
    });
  },
  ww: function ww(date, locale2) {
    return pad(formatFlags.w(date, locale2), 2);
  }
};
function format(val, str) {
  var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var formatStr = str ? String(str) : "YYYY-MM-DDTHH:mm:ss.SSSZ";
  var date = toDate(val);
  if (!isValidDate$1(date)) {
    return "Invalid Date";
  }
  var locale2 = options.locale || locale$1;
  return formatStr.replace(REGEX_FORMAT, function(match, p1) {
    if (p1) {
      return p1;
    }
    if (typeof formatFlags[match] === "function") {
      return "".concat(formatFlags[match](date, locale2));
    }
    return match;
  });
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]")
    return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }
    return arr2;
  }
}
function ownKeys(object, enumerableOnly) {
  var keys2 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(source, true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = void 0;
  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
var formattingTokens = /(\[[^\[]*\])|(MM?M?M?|Do|DD?|ddd?d?|w[o|w]?|YYYY|YY|a|A|hh?|HH?|mm?|ss?|S{1,3}|x|X|ZZ?|.)/g;
var match1 = /\d/;
var match2 = /\d\d/;
var match3 = /\d{3}/;
var match4 = /\d{4}/;
var match1to2 = /\d\d?/;
var matchShortOffset = /[+-]\d\d:?\d\d/;
var matchSigned = /[+-]?\d+/;
var matchTimestamp = /[+-]?\d+(\.\d{1,3})?/;
var YEAR = "year";
var MONTH = "month";
var DAY = "day";
var HOUR = "hour";
var MINUTE = "minute";
var SECOND = "second";
var MILLISECOND = "millisecond";
var parseFlags = {};
var addParseFlag = function addParseFlag2(token, regex, callback) {
  var tokens = Array.isArray(token) ? token : [token];
  var func;
  if (typeof callback === "string") {
    func = function func2(input) {
      var value = parseInt(input, 10);
      return _defineProperty({}, callback, value);
    };
  } else {
    func = callback;
  }
  tokens.forEach(function(key) {
    parseFlags[key] = [regex, func];
  });
};
var escapeStringRegExp = function escapeStringRegExp2(str) {
  return str.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&");
};
var matchWordRegExp = function matchWordRegExp2(localeKey) {
  return function(locale2) {
    var array = locale2[localeKey];
    if (!Array.isArray(array)) {
      throw new Error("Locale[".concat(localeKey, "] need an array"));
    }
    return new RegExp(array.map(escapeStringRegExp).join("|"));
  };
};
var matchWordCallback = function matchWordCallback2(localeKey, key) {
  return function(input, locale2) {
    var array = locale2[localeKey];
    if (!Array.isArray(array)) {
      throw new Error("Locale[".concat(localeKey, "] need an array"));
    }
    var index2 = array.indexOf(input);
    if (index2 < 0) {
      throw new Error("Invalid Word");
    }
    return _defineProperty({}, key, index2);
  };
};
addParseFlag("Y", matchSigned, YEAR);
addParseFlag("YY", match2, function(input) {
  var year = new Date().getFullYear();
  var cent = Math.floor(year / 100);
  var value = parseInt(input, 10);
  value = (value > 68 ? cent - 1 : cent) * 100 + value;
  return _defineProperty({}, YEAR, value);
});
addParseFlag("YYYY", match4, YEAR);
addParseFlag("M", match1to2, function(input) {
  return _defineProperty({}, MONTH, parseInt(input, 10) - 1);
});
addParseFlag("MM", match2, function(input) {
  return _defineProperty({}, MONTH, parseInt(input, 10) - 1);
});
addParseFlag("MMM", matchWordRegExp("monthsShort"), matchWordCallback("monthsShort", MONTH));
addParseFlag("MMMM", matchWordRegExp("months"), matchWordCallback("months", MONTH));
addParseFlag("D", match1to2, DAY);
addParseFlag("DD", match2, DAY);
addParseFlag(["H", "h"], match1to2, HOUR);
addParseFlag(["HH", "hh"], match2, HOUR);
addParseFlag("m", match1to2, MINUTE);
addParseFlag("mm", match2, MINUTE);
addParseFlag("s", match1to2, SECOND);
addParseFlag("ss", match2, SECOND);
addParseFlag("S", match1, function(input) {
  return _defineProperty({}, MILLISECOND, parseInt(input, 10) * 100);
});
addParseFlag("SS", match2, function(input) {
  return _defineProperty({}, MILLISECOND, parseInt(input, 10) * 10);
});
addParseFlag("SSS", match3, MILLISECOND);
function matchMeridiem(locale2) {
  return locale2.meridiemParse || /[ap]\.?m?\.?/i;
}
function defaultIsPM(input) {
  return "".concat(input).toLowerCase().charAt(0) === "p";
}
addParseFlag(["A", "a"], matchMeridiem, function(input, locale2) {
  var isPM = typeof locale2.isPM === "function" ? locale2.isPM(input) : defaultIsPM(input);
  return {
    isPM
  };
});
function offsetFromString(str) {
  var _ref8 = str.match(/([+-]|\d\d)/g) || ["-", "0", "0"], _ref9 = _slicedToArray(_ref8, 3), symbol = _ref9[0], hour = _ref9[1], minute = _ref9[2];
  var minutes = parseInt(hour, 10) * 60 + parseInt(minute, 10);
  if (minutes === 0) {
    return 0;
  }
  return symbol === "+" ? -minutes : +minutes;
}
addParseFlag(["Z", "ZZ"], matchShortOffset, function(input) {
  return {
    offset: offsetFromString(input)
  };
});
addParseFlag("x", matchSigned, function(input) {
  return {
    date: new Date(parseInt(input, 10))
  };
});
addParseFlag("X", matchTimestamp, function(input) {
  return {
    date: new Date(parseFloat(input) * 1e3)
  };
});
addParseFlag("d", match1, "weekday");
addParseFlag("dd", matchWordRegExp("weekdaysMin"), matchWordCallback("weekdaysMin", "weekday"));
addParseFlag("ddd", matchWordRegExp("weekdaysShort"), matchWordCallback("weekdaysShort", "weekday"));
addParseFlag("dddd", matchWordRegExp("weekdays"), matchWordCallback("weekdays", "weekday"));
addParseFlag("w", match1to2, "week");
addParseFlag("ww", match2, "week");
function to24hour(hour, isPM) {
  if (hour !== void 0 && isPM !== void 0) {
    if (isPM) {
      if (hour < 12) {
        return hour + 12;
      }
    } else if (hour === 12) {
      return 0;
    }
  }
  return hour;
}
function getFullInputArray(input) {
  var backupDate = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : new Date();
  var result = [0, 0, 1, 0, 0, 0, 0];
  var backupArr = [backupDate.getFullYear(), backupDate.getMonth(), backupDate.getDate(), backupDate.getHours(), backupDate.getMinutes(), backupDate.getSeconds(), backupDate.getMilliseconds()];
  var useBackup = true;
  for (var i = 0; i < 7; i++) {
    if (input[i] === void 0) {
      result[i] = useBackup ? backupArr[i] : result[i];
    } else {
      result[i] = input[i];
      useBackup = false;
    }
  }
  return result;
}
function createDate$1(y, m2, d2, h3, M2, s2, ms) {
  var date;
  if (y < 100 && y >= 0) {
    date = new Date(y + 400, m2, d2, h3, M2, s2, ms);
    if (isFinite(date.getFullYear())) {
      date.setFullYear(y);
    }
  } else {
    date = new Date(y, m2, d2, h3, M2, s2, ms);
  }
  return date;
}
function createUTCDate() {
  var date;
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  var y = args[0];
  if (y < 100 && y >= 0) {
    args[0] += 400;
    date = new Date(Date.UTC.apply(Date, args));
    if (isFinite(date.getUTCFullYear())) {
      date.setUTCFullYear(y);
    }
  } else {
    date = new Date(Date.UTC.apply(Date, args));
  }
  return date;
}
function makeParser(dateString, format2, locale2) {
  var tokens = format2.match(formattingTokens);
  if (!tokens) {
    throw new Error();
  }
  var length = tokens.length;
  var mark = {};
  for (var i = 0; i < length; i += 1) {
    var token = tokens[i];
    var parseTo = parseFlags[token];
    if (!parseTo) {
      var word = token.replace(/^\[|\]$/g, "");
      if (dateString.indexOf(word) === 0) {
        dateString = dateString.substr(word.length);
      } else {
        throw new Error("not match");
      }
    } else {
      var regex = typeof parseTo[0] === "function" ? parseTo[0](locale2) : parseTo[0];
      var parser = parseTo[1];
      var value = (regex.exec(dateString) || [])[0];
      var obj = parser(value, locale2);
      mark = _objectSpread({}, mark, {}, obj);
      dateString = dateString.replace(value, "");
    }
  }
  return mark;
}
function parse(str, format2) {
  var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  try {
    var _options$locale = options.locale, _locale = _options$locale === void 0 ? locale$1 : _options$locale, _options$backupDate = options.backupDate, backupDate = _options$backupDate === void 0 ? new Date() : _options$backupDate;
    var parseResult = makeParser(str, format2, _locale);
    var year = parseResult.year, month = parseResult.month, day = parseResult.day, hour = parseResult.hour, minute = parseResult.minute, second = parseResult.second, millisecond = parseResult.millisecond, isPM = parseResult.isPM, date = parseResult.date, offset = parseResult.offset, weekday = parseResult.weekday, week = parseResult.week;
    if (date) {
      return date;
    }
    var inputArray = [year, month, day, hour, minute, second, millisecond];
    inputArray[3] = to24hour(inputArray[3], isPM);
    if (week !== void 0 && month === void 0 && day === void 0) {
      var firstDate = startOfWeekYear(year === void 0 ? backupDate : new Date(year, 3), {
        firstDayOfWeek: _locale.firstDayOfWeek,
        firstWeekContainsDate: _locale.firstWeekContainsDate
      });
      return new Date(firstDate.getTime() + (week - 1) * 7 * 24 * 3600 * 1e3);
    }
    var parsedDate;
    var result = getFullInputArray(inputArray, backupDate);
    if (offset !== void 0) {
      result[6] += offset * 60 * 1e3;
      parsedDate = createUTCDate.apply(void 0, _toConsumableArray(result));
    } else {
      parsedDate = createDate$1.apply(void 0, _toConsumableArray(result));
    }
    if (weekday !== void 0 && parsedDate.getDay() !== weekday) {
      return new Date(NaN);
    }
    return parsedDate;
  } catch (e) {
    return new Date(NaN);
  }
}
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a2, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a2, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a2, prop, b[prop]);
    }
  return a2;
};
var __spreadProps = (a2, b) => __defProps(a2, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
const lang = {
  formatLocale: locale$1,
  yearFormat: "YYYY",
  monthFormat: "MMM",
  monthBeforeYear: true
};
let defaultLocale = "en";
const locales = {};
locales[defaultLocale] = lang;
function locale(name, object, isLocal = false) {
  if (typeof name !== "string")
    return locales[defaultLocale];
  let l = defaultLocale;
  if (locales[name]) {
    l = name;
  }
  if (object) {
    locales[name] = object;
    l = name;
  }
  if (!isLocal) {
    defaultLocale = l;
  }
  return locales[name] || locales[defaultLocale];
}
function getLocale(name) {
  return locale(name, void 0, true);
}
function chunk(arr, size) {
  if (!Array.isArray(arr)) {
    return [];
  }
  const result = [];
  const len = arr.length;
  let i = 0;
  size = size || len;
  while (i < len) {
    result.push(arr.slice(i, i += size));
  }
  return result;
}
function last(array) {
  return Array.isArray(array) ? array[array.length - 1] : void 0;
}
function isPlainObject(obj) {
  return Object.prototype.toString.call(obj) === "[object Object]";
}
function pick(obj, props) {
  const res = {};
  if (!isPlainObject(obj))
    return res;
  if (!Array.isArray(props)) {
    props = [props];
  }
  props.forEach((prop) => {
    if (Object.prototype.hasOwnProperty.call(obj, prop)) {
      res[prop] = obj[prop];
    }
  });
  return res;
}
function mergeDeep(target, source) {
  if (!isPlainObject(target)) {
    return {};
  }
  let result = target;
  if (isPlainObject(source)) {
    Object.keys(source).forEach((key) => {
      let value = source[key];
      const targetValue = target[key];
      if (isPlainObject(value) && isPlainObject(targetValue)) {
        value = mergeDeep(targetValue, value);
      }
      result = __spreadProps(__spreadValues({}, result), { [key]: value });
    });
  }
  return result;
}
function padNumber(value) {
  const num = parseInt(String(value), 10);
  return num < 10 ? `0${num}` : `${num}`;
}
function camelcase(str) {
  const camelizeRE = /-(\w)/g;
  return str.replace(camelizeRE, (_, c) => c ? c.toUpperCase() : "");
}
const localeContextKey = "datepicker_locale";
const prefixClassKey = "datepicker_prefixClass";
const getWeekKey = "datepicker_getWeek";
function useLocale() {
  return inject(localeContextKey, shallowRef(getLocale()));
}
function provideLocale(lang2) {
  const locale2 = computed(() => {
    if (isPlainObject(lang2.value)) {
      return mergeDeep(getLocale(), lang2.value);
    }
    return getLocale(lang2.value);
  });
  provide(localeContextKey, locale2);
  return locale2;
}
function providePrefixClass(value) {
  provide(prefixClassKey, value);
}
function usePrefixClass() {
  return inject(prefixClassKey, "mx");
}
function provideGetWeek(value) {
  provide(getWeekKey, value);
}
function useGetWeek() {
  return inject(getWeekKey, getWeek);
}
function getPopupElementSize(element) {
  const originalDisplay = element.style.display;
  const originalVisibility = element.style.visibility;
  element.style.display = "block";
  element.style.visibility = "hidden";
  const styles = window.getComputedStyle(element);
  const width = element.offsetWidth + parseInt(styles.marginLeft, 10) + parseInt(styles.marginRight, 10);
  const height = element.offsetHeight + parseInt(styles.marginTop, 10) + parseInt(styles.marginBottom, 10);
  element.style.display = originalDisplay;
  element.style.visibility = originalVisibility;
  return { width, height };
}
function getRelativePosition(el, targetWidth, targetHeight, fixed) {
  let left = 0;
  let top = 0;
  let offsetX = 0;
  let offsetY = 0;
  const relativeRect = el.getBoundingClientRect();
  const dw = document.documentElement.clientWidth;
  const dh = document.documentElement.clientHeight;
  if (fixed) {
    offsetX = window.pageXOffset + relativeRect.left;
    offsetY = window.pageYOffset + relativeRect.top;
  }
  if (dw - relativeRect.left < targetWidth && relativeRect.right < targetWidth) {
    left = offsetX - relativeRect.left + 1;
  } else if (relativeRect.left + relativeRect.width / 2 <= dw / 2) {
    left = offsetX;
  } else {
    left = offsetX + relativeRect.width - targetWidth;
  }
  if (relativeRect.top <= targetHeight && dh - relativeRect.bottom <= targetHeight) {
    top = offsetY + dh - relativeRect.top - targetHeight;
  } else if (relativeRect.top + relativeRect.height / 2 <= dh / 2) {
    top = offsetY + relativeRect.height;
  } else {
    top = offsetY - targetHeight;
  }
  return { left: `${left}px`, top: `${top}px` };
}
function getScrollParent(node, until = document.body) {
  if (!node || node === until) {
    return null;
  }
  const style = (value, prop) => getComputedStyle(value, null).getPropertyValue(prop);
  const regex = /(auto|scroll)/;
  const scroll = regex.test(style(node, "overflow") + style(node, "overflow-y") + style(node, "overflow-x"));
  return scroll ? node : getScrollParent(node.parentElement, until);
}
let scrollBarWidth;
function getScrollbarWidth() {
  if (typeof window === "undefined")
    return 0;
  if (scrollBarWidth !== void 0)
    return scrollBarWidth;
  const outer = document.createElement("div");
  outer.style.visibility = "hidden";
  outer.style.overflow = "scroll";
  outer.style.width = "100px";
  outer.style.position = "absolute";
  outer.style.top = "-9999px";
  document.body.appendChild(outer);
  const inner = document.createElement("div");
  inner.style.width = "100%";
  outer.appendChild(inner);
  scrollBarWidth = outer.offsetWidth - inner.offsetWidth;
  outer.parentNode.removeChild(outer);
  return scrollBarWidth;
}
const mousedownEvent = "ontouchend" in document ? "touchstart" : "mousedown";
function rafThrottle(fn) {
  let isRunning = false;
  return function fnBinfRaf(...args) {
    if (isRunning)
      return;
    isRunning = true;
    requestAnimationFrame(() => {
      isRunning = false;
      fn.apply(this, args);
    });
  };
}
function defineVueComponent(setup, props) {
  return { setup, name: setup.name, props };
}
function withDefault(props, defaultProps) {
  const result = new Proxy(props, {
    get(target, key) {
      const value = target[key];
      if (value !== void 0) {
        return value;
      }
      return defaultProps[key];
    }
  });
  return result;
}
const keys = () => (props) => props;
const resolveProps = (obj, booleanKeys2) => {
  const props = {};
  for (const key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      const camelizeKey = camelcase(key);
      let value = obj[key];
      if (booleanKeys2.indexOf(camelizeKey) !== -1 && value === "") {
        value = true;
      }
      props[camelizeKey] = value;
    }
  }
  return props;
};
function Popup(originalProps, {
  slots
}) {
  const props = withDefault(originalProps, {
    appendToBody: true
  });
  const prefixClass = usePrefixClass();
  const popup = ref(null);
  const position = ref({
    left: "",
    top: ""
  });
  const displayPopup = () => {
    if (!props.visible || !popup.value)
      return;
    const relativeElement = props.getRelativeElement();
    if (!relativeElement)
      return;
    const {
      width,
      height
    } = getPopupElementSize(popup.value);
    position.value = getRelativePosition(relativeElement, width, height, props.appendToBody);
  };
  watchEffect(displayPopup, {
    flush: "post"
  });
  watchEffect((onInvalidate) => {
    const relativeElement = props.getRelativeElement();
    if (!relativeElement)
      return;
    const scrollElement = getScrollParent(relativeElement) || window;
    const handleMove = rafThrottle(displayPopup);
    scrollElement.addEventListener("scroll", handleMove);
    window.addEventListener("resize", handleMove);
    onInvalidate(() => {
      scrollElement.removeEventListener("scroll", handleMove);
      window.removeEventListener("resize", handleMove);
    });
  }, {
    flush: "post"
  });
  const handleClickOutside = (evt) => {
    if (!props.visible)
      return;
    const target = evt.target;
    const el = popup.value;
    const relativeElement = props.getRelativeElement();
    if (el && !el.contains(target) && relativeElement && !relativeElement.contains(target)) {
      props.onClickOutside(evt);
    }
  };
  watchEffect((onInvalidate) => {
    document.addEventListener(mousedownEvent, handleClickOutside);
    onInvalidate(() => {
      document.removeEventListener(mousedownEvent, handleClickOutside);
    });
  });
  return () => {
    return createVNode(Teleport, {
      "to": "body",
      "disabled": !props.appendToBody
    }, {
      default: () => [createVNode(Transition, {
        "name": `${prefixClass}-zoom-in-down`
      }, {
        default: () => {
          var _a;
          return [props.visible && createVNode("div", {
            "ref": popup,
            "class": `${prefixClass}-datepicker-main ${prefixClass}-datepicker-popup ${props.className}`,
            "style": [__spreadValues({
              position: "absolute"
            }, position.value), props.style || {}]
          }, [(_a = slots.default) == null ? void 0 : _a.call(slots)])];
        }
      })]
    });
  };
}
const popupProps = keys()(["style", "className", "visible", "appendToBody", "onClickOutside", "getRelativeElement"]);
var Popup$1 = defineVueComponent(Popup, popupProps);
const _hoisted_1$2$1 = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 1024 1024",
  width: "1em",
  height: "1em"
};
const _hoisted_2$2$1 = /* @__PURE__ */ createElementVNode("path", { d: "M940.218 107.055H730.764v-60.51H665.6v60.51H363.055v-60.51H297.89v60.51H83.78c-18.617 0-32.581 13.963-32.581 32.581v805.237c0 18.618 13.964 32.582 32.582 32.582h861.09c18.619 0 32.583-13.964 32.583-32.582V139.636c-4.655-18.618-18.619-32.581-37.237-32.581zm-642.327 65.163v60.51h65.164v-60.51h307.2v60.51h65.163v-60.51h176.873v204.8H116.364v-204.8H297.89zM116.364 912.291V442.18H912.29v470.11H116.364z" }, null, -1);
const _hoisted_3$2$1 = [
  _hoisted_2$2$1
];
function render$2(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$2$1, _hoisted_3$2$1);
}
const _hoisted_1$1$1 = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 1024 1024",
  width: "1em",
  height: "1em"
};
const _hoisted_2$1$1 = /* @__PURE__ */ createElementVNode("path", { d: "M810.005 274.005 572.011 512l237.994 237.995-60.01 60.01L512 572.011 274.005 810.005l-60.01-60.01L451.989 512 213.995 274.005l60.01-60.01L512 451.989l237.995-237.994z" }, null, -1);
const _hoisted_3$1$1 = [
  _hoisted_2$1$1
];
function render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$1$1, _hoisted_3$1$1);
}
const _hoisted_1$4 = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24",
  width: "1em",
  height: "1em"
};
const _hoisted_2$4 = /* @__PURE__ */ createElementVNode("path", {
  d: "M0 0h24v24H0z",
  fill: "none"
}, null, -1);
const _hoisted_3$4 = /* @__PURE__ */ createElementVNode("path", { d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z" }, null, -1);
const _hoisted_4$4 = /* @__PURE__ */ createElementVNode("path", { d: "M12.5 7H11v6l5.25 3.15.75-1.23-4.5-2.67z" }, null, -1);
const _hoisted_5$2 = [
  _hoisted_2$4,
  _hoisted_3$4,
  _hoisted_4$4
];
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$4, _hoisted_5$2);
}
function createDate(y, M2 = 0, d2 = 1, h22 = 0, m2 = 0, s2 = 0, ms = 0) {
  const date = new Date(y, M2, d2, h22, m2, s2, ms);
  if (y < 100 && y >= 0) {
    date.setFullYear(y);
  }
  return date;
}
function isValidDate(date) {
  return date instanceof Date && !isNaN(date.getTime());
}
function isValidRangeDate(dates) {
  return Array.isArray(dates) && dates.length === 2 && dates.every(isValidDate) && dates[0] <= dates[1];
}
function isValidDates(dates) {
  return Array.isArray(dates) && dates.every(isValidDate);
}
function getValidDate(...values) {
  if (values[0] !== void 0 && values[0] !== null) {
    const date = new Date(values[0]);
    if (isValidDate(date)) {
      return date;
    }
  }
  const rest = values.slice(1);
  if (rest.length) {
    return getValidDate(...rest);
  }
  return new Date();
}
function startOfYear(value) {
  const date = new Date(value);
  date.setMonth(0, 1);
  date.setHours(0, 0, 0, 0);
  return date;
}
function startOfMonth(value) {
  const date = new Date(value);
  date.setDate(1);
  date.setHours(0, 0, 0, 0);
  return date;
}
function startOfDay(value) {
  const date = new Date(value);
  date.setHours(0, 0, 0, 0);
  return date;
}
function getCalendar({
  firstDayOfWeek,
  year,
  month
}) {
  const arr = [];
  const calendar = createDate(year, month, 0);
  const lastDayInLastMonth = calendar.getDate();
  const firstDayInLastMonth = lastDayInLastMonth - (calendar.getDay() + 7 - firstDayOfWeek) % 7;
  for (let i = firstDayInLastMonth; i <= lastDayInLastMonth; i++) {
    arr.push(createDate(year, month, i - lastDayInLastMonth));
  }
  calendar.setMonth(month + 1, 0);
  const lastDayInCurrentMonth = calendar.getDate();
  for (let i = 1; i <= lastDayInCurrentMonth; i++) {
    arr.push(createDate(year, month, i));
  }
  const lastMonthLength = lastDayInLastMonth - firstDayInLastMonth + 1;
  const nextMonthLength = 6 * 7 - lastMonthLength - lastDayInCurrentMonth;
  for (let i = 1; i <= nextMonthLength; i++) {
    arr.push(createDate(year, month, lastDayInCurrentMonth + i));
  }
  return arr;
}
function setMonth(dirtyDate, dirtyMonth) {
  const date = new Date(dirtyDate);
  const month = typeof dirtyMonth === "function" ? dirtyMonth(date.getMonth()) : Number(dirtyMonth);
  const year = date.getFullYear();
  const daysInMonth = createDate(year, month + 1, 0).getDate();
  const day = date.getDate();
  date.setMonth(month, Math.min(day, daysInMonth));
  return date;
}
function setYear(dirtyDate, dirtyYear) {
  const date = new Date(dirtyDate);
  const year = typeof dirtyYear === "function" ? dirtyYear(date.getFullYear()) : dirtyYear;
  date.setFullYear(year);
  return date;
}
function diffCalendarMonths(dirtyDateLeft, dirtyDateRight) {
  const dateRight = new Date(dirtyDateRight);
  const dateLeft = new Date(dirtyDateLeft);
  const yearDiff = dateRight.getFullYear() - dateLeft.getFullYear();
  const monthDiff = dateRight.getMonth() - dateLeft.getMonth();
  return yearDiff * 12 + monthDiff;
}
function assignTime(target, source) {
  const date = new Date(target);
  const time = new Date(source);
  date.setHours(time.getHours(), time.getMinutes(), time.getSeconds());
  return date;
}
function PickerInput(originalProps, {
  slots
}) {
  const props = withDefault(originalProps, {
    editable: true,
    disabled: false,
    clearable: true,
    range: false,
    multiple: false
  });
  const prefixClass = usePrefixClass();
  const userInput = ref(null);
  const innerSeparator = computed(() => {
    return props.separator || (props.range ? " ~ " : ",");
  });
  const isValidValue = (value) => {
    if (props.range) {
      return isValidRangeDate(value) && value.every((date) => !props.disabledDate(date));
    }
    if (props.multiple) {
      return isValidDates(value) && value.every((date) => !props.disabledDate(date));
    }
    return isValidDate(value) && !props.disabledDate(value);
  };
  const text = computed(() => {
    if (userInput.value !== null) {
      return userInput.value;
    }
    if (typeof props.renderInputText === "function") {
      return props.renderInputText(props.value);
    }
    if (!isValidValue(props.value)) {
      return "";
    }
    if (Array.isArray(props.value)) {
      return props.value.map((v) => props.formatDate(v)).join(innerSeparator.value);
    }
    return props.formatDate(props.value);
  });
  const handleClear = (evt) => {
    var _a;
    if (evt) {
      evt.stopPropagation();
    }
    props.onChange(props.range ? [null, null] : null);
    (_a = props.onClear) == null ? void 0 : _a.call(props);
  };
  const handleChange = () => {
    var _a;
    if (!props.editable || userInput.value === null)
      return;
    const text2 = userInput.value.trim();
    userInput.value = null;
    if (text2 === "") {
      handleClear();
      return;
    }
    let date;
    if (props.range) {
      let arr = text2.split(innerSeparator.value);
      if (arr.length !== 2) {
        arr = text2.split(innerSeparator.value.trim());
      }
      date = arr.map((v) => props.parseDate(v.trim()));
    } else if (props.multiple) {
      date = text2.split(innerSeparator.value).map((v) => props.parseDate(v.trim()));
    } else {
      date = props.parseDate(text2);
    }
    if (isValidValue(date)) {
      props.onChange(date);
    } else {
      (_a = props.onInputError) == null ? void 0 : _a.call(props, text2);
    }
  };
  const handleInput = (evt) => {
    userInput.value = typeof evt === "string" ? evt : evt.target.value;
  };
  const handleKeydown = (evt) => {
    const {
      keyCode
    } = evt;
    if (keyCode === 9) {
      props.onBlur();
    } else if (keyCode === 13) {
      handleChange();
    }
  };
  return () => {
    var _a, _b, _c;
    const showClearIcon = !props.disabled && props.clearable && text.value;
    const inputProps = __spreadProps(__spreadValues({
      name: "date",
      type: "text",
      autocomplete: "off",
      value: text.value,
      class: props.inputClass || `${prefixClass}-input`,
      readonly: !props.editable,
      disabled: props.disabled,
      placeholder: props.placeholder
    }, props.inputAttr), {
      onFocus: props.onFocus,
      onKeydown: handleKeydown,
      onInput: handleInput,
      onChange: handleChange
    });
    return createVNode("div", {
      "class": `${prefixClass}-input-wrapper`,
      "onClick": props.onClick
    }, [((_a = slots.input) == null ? void 0 : _a.call(slots, inputProps)) || createVNode("input", inputProps, null), showClearIcon ? createVNode("i", {
      "class": `${prefixClass}-icon-clear`,
      "onClick": handleClear
    }, [((_b = slots["icon-clear"]) == null ? void 0 : _b.call(slots)) || createVNode(render$1, null, null)]) : null, createVNode("i", {
      "class": `${prefixClass}-icon-calendar`
    }, [((_c = slots["icon-calendar"]) == null ? void 0 : _c.call(slots)) || createVNode(render$2, null, null)])]);
  };
}
const pickerInputBaseProps = keys()(["placeholder", "editable", "disabled", "clearable", "inputClass", "inputAttr", "range", "multiple", "separator", "renderInputText", "onInputError", "onClear"]);
const pickerInputProps = keys()(["value", "formatDate", "parseDate", "disabledDate", "onChange", "onFocus", "onBlur", "onClick", ...pickerInputBaseProps]);
var PickerInput$1 = defineVueComponent(PickerInput, pickerInputProps);
function Picker(originalProps, {
  slots
}) {
  var _a;
  const props = withDefault(originalProps, {
    prefixClass: "mx",
    valueType: "date",
    format: "YYYY-MM-DD",
    type: "date",
    disabledDate: () => false,
    disabledTime: () => false,
    confirmText: "OK"
  });
  providePrefixClass(props.prefixClass);
  provideGetWeek(((_a = props.formatter) == null ? void 0 : _a.getWeek) || getWeek);
  const locale2 = provideLocale(toRef(originalProps, "lang"));
  const container = ref();
  const getContainer = () => container.value;
  const defaultOpen = ref(false);
  const popupVisible = computed(() => {
    return !props.disabled && (typeof props.open === "boolean" ? props.open : defaultOpen.value);
  });
  const openPopup = () => {
    var _a2, _b;
    if (props.disabled || popupVisible.value)
      return;
    defaultOpen.value = true;
    (_a2 = props["onUpdate:open"]) == null ? void 0 : _a2.call(props, true);
    (_b = props.onOpen) == null ? void 0 : _b.call(props);
  };
  const closePopup = () => {
    var _a2, _b;
    if (!popupVisible.value)
      return;
    defaultOpen.value = false;
    (_a2 = props["onUpdate:open"]) == null ? void 0 : _a2.call(props, false);
    (_b = props.onClose) == null ? void 0 : _b.call(props);
  };
  const formatDate = (date, fmt) => {
    fmt = fmt || props.format;
    if (isPlainObject(props.formatter) && typeof props.formatter.stringify === "function") {
      return props.formatter.stringify(date, fmt);
    }
    return format(date, fmt, {
      locale: locale2.value.formatLocale
    });
  };
  const parseDate = (value, fmt) => {
    fmt = fmt || props.format;
    if (isPlainObject(props.formatter) && typeof props.formatter.parse === "function") {
      return props.formatter.parse(value, fmt);
    }
    const backupDate = new Date();
    return parse(value, fmt, {
      locale: locale2.value.formatLocale,
      backupDate
    });
  };
  const value2date = (value) => {
    switch (props.valueType) {
      case "date":
        return value instanceof Date ? new Date(value.getTime()) : new Date(NaN);
      case "timestamp":
        return typeof value === "number" ? new Date(value) : new Date(NaN);
      case "format":
        return typeof value === "string" ? parseDate(value) : new Date(NaN);
      default:
        return typeof value === "string" ? parseDate(value, props.valueType) : new Date(NaN);
    }
  };
  const date2value = (date) => {
    if (!isValidDate(date))
      return null;
    switch (props.valueType) {
      case "date":
        return date;
      case "timestamp":
        return date.getTime();
      case "format":
        return formatDate(date);
      default:
        return formatDate(date, props.valueType);
    }
  };
  const innerValue = computed(() => {
    const value = props.value;
    if (props.range) {
      return (Array.isArray(value) ? value.slice(0, 2) : [null, null]).map(value2date);
    }
    if (props.multiple) {
      return (Array.isArray(value) ? value : []).map(value2date);
    }
    return value2date(value);
  });
  const emitValue = (date, type, close = true) => {
    var _a2, _b;
    const value = Array.isArray(date) ? date.map(date2value) : date2value(date);
    (_a2 = props["onUpdate:value"]) == null ? void 0 : _a2.call(props, value);
    (_b = props.onChange) == null ? void 0 : _b.call(props, value, type);
    if (close) {
      closePopup();
    }
    return value;
  };
  const currentValue = ref(new Date());
  watchEffect(() => {
    if (popupVisible.value) {
      currentValue.value = innerValue.value;
    }
  });
  const handleSelect = (val, type) => {
    if (props.confirm) {
      currentValue.value = val;
    } else {
      emitValue(val, type, !props.multiple && (type === props.type || type === "time"));
    }
  };
  const handleConfirm = () => {
    var _a2;
    const value = emitValue(currentValue.value);
    (_a2 = props.onConfirm) == null ? void 0 : _a2.call(props, value);
  };
  const disabledDateTime = (v) => {
    return props.disabledDate(v) || props.disabledTime(v);
  };
  const renderSidebar = (slotProps) => {
    var _a2;
    const {
      prefixClass
    } = props;
    return createVNode("div", {
      "class": `${prefixClass}-datepicker-sidebar`
    }, [(_a2 = slots.sidebar) == null ? void 0 : _a2.call(slots, slotProps), (props.shortcuts || []).map((v, i) => createVNode("button", {
      "key": i,
      "data-index": i,
      "type": "button",
      "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-btn-shortcut`,
      "onClick": () => {
        var _a3;
        const date = (_a3 = v.onClick) == null ? void 0 : _a3.call(v);
        if (date) {
          emitValue(date);
        }
      }
    }, [v.text]))]);
  };
  return () => {
    var _a2, _b;
    const {
      prefixClass,
      disabled,
      confirm,
      range,
      popupClass,
      popupStyle,
      appendToBody
    } = props;
    const slotProps = {
      value: currentValue.value,
      ["onUpdate:value"]: handleSelect,
      emit: emitValue
    };
    const header = slots.header && createVNode("div", {
      "class": `${prefixClass}-datepicker-header`
    }, [slots.header(slotProps)]);
    const footer = (slots.footer || confirm) && createVNode("div", {
      "class": `${prefixClass}-datepicker-footer`
    }, [(_a2 = slots.footer) == null ? void 0 : _a2.call(slots, slotProps), confirm && createVNode("button", {
      "type": "button",
      "class": `${prefixClass}-btn ${prefixClass}-datepicker-btn-confirm`,
      "onClick": handleConfirm
    }, [props.confirmText])]);
    const content = (_b = slots.content) == null ? void 0 : _b.call(slots, slotProps);
    const sidedar = (slots.sidebar || props.shortcuts) && renderSidebar(slotProps);
    return createVNode("div", {
      "ref": container,
      "class": {
        [`${prefixClass}-datepicker`]: true,
        [`${prefixClass}-datepicker-range`]: range,
        disabled
      }
    }, [createVNode(PickerInput$1, __spreadProps(__spreadValues({}, pick(props, pickerInputBaseProps)), {
      "value": innerValue.value,
      "formatDate": formatDate,
      "parseDate": parseDate,
      "disabledDate": disabledDateTime,
      "onChange": emitValue,
      "onClick": openPopup,
      "onFocus": openPopup,
      "onBlur": closePopup
    }), pick(slots, ["icon-calendar", "icon-clear", "input"])), createVNode(Popup$1, {
      "className": popupClass,
      "style": popupStyle,
      "visible": popupVisible.value,
      "appendToBody": appendToBody,
      "getRelativeElement": getContainer,
      "onClickOutside": closePopup
    }, {
      default: () => [sidedar, createVNode("div", {
        "class": `${prefixClass}-datepicker-content`
      }, [header, content, footer])]
    })]);
  };
}
const pickerbaseProps = keys()(["value", "valueType", "type", "format", "formatter", "lang", "prefixClass", "appendToBody", "open", "popupClass", "popupStyle", "confirm", "confirmText", "shortcuts", "disabledDate", "disabledTime", "onOpen", "onClose", "onConfirm", "onChange", "onUpdate:open", "onUpdate:value"]);
const pickerProps = [...pickerbaseProps, ...pickerInputBaseProps];
var Picker$1 = defineVueComponent(Picker, pickerProps);
function ButtonIcon(_a) {
  var _b = _a, {
    value
  } = _b, rest = __objRest(_b, [
    "value"
  ]);
  const prefixClass = usePrefixClass();
  return createVNode("button", __spreadProps(__spreadValues({}, rest), {
    "type": "button",
    "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-btn-icon-${value}`
  }), [createVNode("i", {
    "class": `${prefixClass}-icon-${value}`
  }, null)]);
}
function TableHeader({
  type,
  calendar,
  onUpdateCalendar
}, {
  slots
}) {
  var _a;
  const prefixClass = usePrefixClass();
  const lastMonth = () => {
    onUpdateCalendar(setMonth(calendar, (v) => v - 1));
  };
  const nextMonth = () => {
    onUpdateCalendar(setMonth(calendar, (v) => v + 1));
  };
  const lastYear = () => {
    onUpdateCalendar(setYear(calendar, (v) => v - 1));
  };
  const nextYear = () => {
    onUpdateCalendar(setYear(calendar, (v) => v + 1));
  };
  const lastDecade = () => {
    onUpdateCalendar(setYear(calendar, (v) => v - 10));
  };
  const nextDecade = () => {
    onUpdateCalendar(setYear(calendar, (v) => v + 10));
  };
  return createVNode("div", {
    "class": `${prefixClass}-calendar-header`
  }, [createVNode(ButtonIcon, {
    "value": "double-left",
    "onClick": type === "year" ? lastDecade : lastYear
  }, null), type === "date" && createVNode(ButtonIcon, {
    "value": "left",
    "onClick": lastMonth
  }, null), createVNode(ButtonIcon, {
    "value": "double-right",
    "onClick": type === "year" ? nextDecade : nextYear
  }, null), type === "date" && createVNode(ButtonIcon, {
    "value": "right",
    "onClick": nextMonth
  }, null), createVNode("span", {
    "class": `${prefixClass}-calendar-header-label`
  }, [(_a = slots.default) == null ? void 0 : _a.call(slots)])]);
}
function TableDate({
  calendar,
  isWeekMode,
  showWeekNumber,
  titleFormat,
  getWeekActive,
  getCellClasses,
  onSelect,
  onUpdatePanel,
  onUpdateCalendar,
  onDateMouseEnter,
  onDateMouseLeave
}) {
  const prefixClass = usePrefixClass();
  const getWeekNumber = useGetWeek();
  const locale2 = useLocale().value;
  const {
    yearFormat,
    monthBeforeYear,
    monthFormat = "MMM",
    formatLocale
  } = locale2;
  const firstDayOfWeek = formatLocale.firstDayOfWeek || 0;
  let days = locale2.days || formatLocale.weekdaysMin;
  days = days.concat(days).slice(firstDayOfWeek, firstDayOfWeek + 7);
  const year = calendar.getFullYear();
  const month = calendar.getMonth();
  const dates = chunk(getCalendar({
    firstDayOfWeek,
    year,
    month
  }), 7);
  const formatDate = (date, fmt) => {
    return format(date, fmt, {
      locale: locale2.formatLocale
    });
  };
  const handlePanelChange = (panel) => {
    onUpdatePanel(panel);
  };
  const getCellDate = (el) => {
    const index2 = el.getAttribute("data-index");
    const [row, col] = index2.split(",").map((v) => parseInt(v, 10));
    const value = dates[row][col];
    return new Date(value);
  };
  const handleCellClick = (evt) => {
    onSelect(getCellDate(evt.currentTarget));
  };
  const handleMouseEnter = (evt) => {
    if (onDateMouseEnter) {
      onDateMouseEnter(getCellDate(evt.currentTarget));
    }
  };
  const handleMouseLeave = (evt) => {
    if (onDateMouseLeave) {
      onDateMouseLeave(getCellDate(evt.currentTarget));
    }
  };
  const yearLabel = createVNode("button", {
    "type": "button",
    "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-btn-current-year`,
    "onClick": () => handlePanelChange("year")
  }, [formatDate(calendar, yearFormat)]);
  const monthLabel = createVNode("button", {
    "type": "button",
    "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-btn-current-month`,
    "onClick": () => handlePanelChange("month")
  }, [formatDate(calendar, monthFormat)]);
  showWeekNumber = typeof showWeekNumber === "boolean" ? showWeekNumber : isWeekMode;
  return createVNode("div", {
    "class": [`${prefixClass}-calendar ${prefixClass}-calendar-panel-date`, {
      [`${prefixClass}-calendar-week-mode`]: isWeekMode
    }]
  }, [createVNode(TableHeader, {
    "type": "date",
    "calendar": calendar,
    "onUpdateCalendar": onUpdateCalendar
  }, {
    default: () => [monthBeforeYear ? [monthLabel, yearLabel] : [yearLabel, monthLabel]]
  }), createVNode("div", {
    "class": `${prefixClass}-calendar-content`
  }, [createVNode("table", {
    "class": `${prefixClass}-table ${prefixClass}-table-date`
  }, [createVNode("thead", null, [createVNode("tr", null, [showWeekNumber && createVNode("th", {
    "class": `${prefixClass}-week-number-header`
  }, null), days.map((day) => createVNode("th", {
    "key": day
  }, [day]))])]), createVNode("tbody", null, [dates.map((row, i) => createVNode("tr", {
    "key": i,
    "class": [`${prefixClass}-date-row`, {
      [`${prefixClass}-active-week`]: getWeekActive(row)
    }]
  }, [showWeekNumber && createVNode("td", {
    "class": `${prefixClass}-week-number`,
    "data-index": `${i},0`,
    "onClick": handleCellClick
  }, [createVNode("div", null, [getWeekNumber(row[0])])]), row.map((cell, j) => createVNode("td", {
    "key": j,
    "class": ["cell", getCellClasses(cell)],
    "title": formatDate(cell, titleFormat),
    "data-index": `${i},${j}`,
    "onClick": handleCellClick,
    "onMouseenter": handleMouseEnter,
    "onMouseleave": handleMouseLeave
  }, [createVNode("div", null, [cell.getDate()])]))]))])])])]);
}
function TableMonth({
  calendar,
  getCellClasses,
  onSelect,
  onUpdateCalendar,
  onUpdatePanel
}) {
  const prefixClass = usePrefixClass();
  const locale2 = useLocale().value;
  const months = locale2.months || locale2.formatLocale.monthsShort;
  const getDate = (month) => {
    return createDate(calendar.getFullYear(), month);
  };
  const handleClick = (evt) => {
    const target = evt.currentTarget;
    const month = target.getAttribute("data-month");
    onSelect(getDate(parseInt(month, 10)));
  };
  return createVNode("div", {
    "class": `${prefixClass}-calendar ${prefixClass}-calendar-panel-month`
  }, [createVNode(TableHeader, {
    "type": "month",
    "calendar": calendar,
    "onUpdateCalendar": onUpdateCalendar
  }, {
    default: () => [createVNode("button", {
      "type": "button",
      "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-btn-current-year`,
      "onClick": () => onUpdatePanel("year")
    }, [calendar.getFullYear()])]
  }), createVNode("div", {
    "class": `${prefixClass}-calendar-content`
  }, [createVNode("table", {
    "class": `${prefixClass}-table ${prefixClass}-table-month`
  }, [chunk(months, 3).map((row, i) => createVNode("tr", {
    "key": i
  }, [row.map((cell, j) => {
    const month = i * 3 + j;
    return createVNode("td", {
      "key": j,
      "class": ["cell", getCellClasses(getDate(month))],
      "data-month": month,
      "onClick": handleClick
    }, [createVNode("div", null, [cell])]);
  })]))])])]);
}
const getDefaultYears = (calendar) => {
  const firstYear = Math.floor(calendar.getFullYear() / 10) * 10;
  const years = [];
  for (let i = 0; i < 10; i++) {
    years.push(firstYear + i);
  }
  return chunk(years, 2);
};
function TableYear({
  calendar,
  getCellClasses = () => [],
  getYearPanel = getDefaultYears,
  onSelect,
  onUpdateCalendar
}) {
  const prefixClass = usePrefixClass();
  const getDate = (year) => {
    return createDate(year, 0);
  };
  const handleClick = (evt) => {
    const target = evt.currentTarget;
    const year = target.getAttribute("data-year");
    onSelect(getDate(parseInt(year, 10)));
  };
  const years = getYearPanel(new Date(calendar));
  const firstYear = years[0][0];
  const lastYear = last(last(years));
  return createVNode("div", {
    "class": `${prefixClass}-calendar ${prefixClass}-calendar-panel-year`
  }, [createVNode(TableHeader, {
    "type": "year",
    "calendar": calendar,
    "onUpdateCalendar": onUpdateCalendar
  }, {
    default: () => [createVNode("span", null, [firstYear]), createVNode("span", {
      "class": `${prefixClass}-calendar-decade-separator`
    }, null), createVNode("span", null, [lastYear])]
  }), createVNode("div", {
    "class": `${prefixClass}-calendar-content`
  }, [createVNode("table", {
    "class": `${prefixClass}-table ${prefixClass}-table-year`
  }, [years.map((row, i) => createVNode("tr", {
    "key": i
  }, [row.map((cell, j) => createVNode("td", {
    "key": j,
    "class": ["cell", getCellClasses(getDate(cell))],
    "data-year": cell,
    "onClick": handleClick
  }, [createVNode("div", null, [cell])]))]))])])]);
}
function Calendar(originalProps) {
  const props = withDefault(originalProps, {
    defaultValue: startOfDay(new Date()),
    type: "date",
    disabledDate: () => false,
    getClasses: () => [],
    titleFormat: "YYYY-MM-DD"
  });
  const innerValue = computed(() => {
    const value = Array.isArray(props.value) ? props.value : [props.value];
    return value.filter(isValidDate).map((v) => {
      if (props.type === "year")
        return startOfYear(v);
      if (props.type === "month")
        return startOfMonth(v);
      return startOfDay(v);
    });
  });
  const innerCalendar = ref(new Date());
  watchEffect(() => {
    let calendarDate = props.calendar;
    if (!isValidDate(calendarDate)) {
      const {
        length
      } = innerValue.value;
      calendarDate = getValidDate(length > 0 ? innerValue.value[length - 1] : props.defaultValue);
    }
    innerCalendar.value = startOfMonth(calendarDate);
  });
  const handleCalendarChange = (calendar) => {
    var _a;
    innerCalendar.value = calendar;
    (_a = props.onCalendarChange) == null ? void 0 : _a.call(props, calendar);
  };
  const panel = ref("date");
  watchEffect(() => {
    const panels = ["date", "month", "year"];
    const index2 = Math.max(panels.indexOf(props.type), panels.indexOf(props.defaultPanel));
    panel.value = index2 !== -1 ? panels[index2] : "date";
  });
  const handelPanelChange = (value) => {
    var _a;
    const oldPanel = panel.value;
    panel.value = value;
    (_a = props.onPanelChange) == null ? void 0 : _a.call(props, value, oldPanel);
  };
  const isDisabled = (date) => {
    return props.disabledDate(new Date(date), innerValue.value);
  };
  const emitDate = (date, type) => {
    var _a, _b, _c;
    if (!isDisabled(date)) {
      (_a = props.onPick) == null ? void 0 : _a.call(props, date);
      if (props.multiple === true) {
        const nextDates = innerValue.value.filter((v) => v.getTime() !== date.getTime());
        if (nextDates.length === innerValue.value.length) {
          nextDates.push(date);
        }
        (_b = props["onUpdate:value"]) == null ? void 0 : _b.call(props, nextDates, type);
      } else {
        (_c = props["onUpdate:value"]) == null ? void 0 : _c.call(props, date, type);
      }
    }
  };
  const handleSelectDate = (date) => {
    emitDate(date, props.type === "week" ? "week" : "date");
  };
  const handleSelectYear = (date) => {
    if (props.type === "year") {
      emitDate(date, "year");
    } else {
      handleCalendarChange(date);
      handelPanelChange("month");
      if (props.partialUpdate && innerValue.value.length === 1) {
        const value = setYear(innerValue.value[0], date.getFullYear());
        emitDate(value, "year");
      }
    }
  };
  const handleSelectMonth = (date) => {
    if (props.type === "month") {
      emitDate(date, "month");
    } else {
      handleCalendarChange(date);
      handelPanelChange("date");
      if (props.partialUpdate && innerValue.value.length === 1) {
        const value = setMonth(setYear(innerValue.value[0], date.getFullYear()), date.getMonth());
        emitDate(value, "month");
      }
    }
  };
  const getCellClasses = (cellDate, classes = []) => {
    if (isDisabled(cellDate)) {
      classes.push("disabled");
    } else if (innerValue.value.some((v) => v.getTime() === cellDate.getTime())) {
      classes.push("active");
    }
    return classes.concat(props.getClasses(cellDate, innerValue.value, classes.join(" ")));
  };
  const getDateClasses = (cellDate) => {
    const notCurrentMonth = cellDate.getMonth() !== innerCalendar.value.getMonth();
    const classes = [];
    if (cellDate.getTime() === new Date().setHours(0, 0, 0, 0)) {
      classes.push("today");
    }
    if (notCurrentMonth) {
      classes.push("not-current-month");
    }
    return getCellClasses(cellDate, classes);
  };
  const getMonthClasses = (cellDate) => {
    if (props.type !== "month") {
      return innerCalendar.value.getMonth() === cellDate.getMonth() ? "active" : "";
    }
    return getCellClasses(cellDate);
  };
  const getYearClasses = (cellDate) => {
    if (props.type !== "year") {
      return innerCalendar.value.getFullYear() === cellDate.getFullYear() ? "active" : "";
    }
    return getCellClasses(cellDate);
  };
  const getWeekActive = (row) => {
    if (props.type !== "week")
      return false;
    const start = row[0].getTime();
    const end = row[6].getTime();
    return innerValue.value.some((v) => {
      const time = v.getTime();
      return time >= start && time <= end;
    });
  };
  return () => {
    if (panel.value === "year") {
      return createVNode(TableYear, {
        "calendar": innerCalendar.value,
        "getCellClasses": getYearClasses,
        "getYearPanel": props.getYearPanel,
        "onSelect": handleSelectYear,
        "onUpdateCalendar": handleCalendarChange
      }, null);
    }
    if (panel.value === "month") {
      return createVNode(TableMonth, {
        "calendar": innerCalendar.value,
        "getCellClasses": getMonthClasses,
        "onSelect": handleSelectMonth,
        "onUpdatePanel": handelPanelChange,
        "onUpdateCalendar": handleCalendarChange
      }, null);
    }
    return createVNode(TableDate, {
      "isWeekMode": props.type === "week",
      "showWeekNumber": props.showWeekNumber,
      "titleFormat": props.titleFormat,
      "calendar": innerCalendar.value,
      "getCellClasses": getDateClasses,
      "getWeekActive": getWeekActive,
      "onSelect": handleSelectDate,
      "onUpdatePanel": handelPanelChange,
      "onUpdateCalendar": handleCalendarChange,
      "onDateMouseEnter": props.onDateMouseEnter,
      "onDateMouseLeave": props.onDateMouseLeave
    }, null);
  };
}
const calendarProps = keys()(["type", "value", "defaultValue", "defaultPanel", "disabledDate", "getClasses", "calendar", "multiple", "partialUpdate", "showWeekNumber", "titleFormat", "getYearPanel", "onDateMouseEnter", "onDateMouseLeave", "onCalendarChange", "onPanelChange", "onUpdate:value", "onPick"]);
var Calendar$1 = defineVueComponent(Calendar, calendarProps);
const inRange = (date, range) => {
  const value = date.getTime();
  let [min, max] = range.map((v) => v.getTime());
  if (min > max) {
    [min, max] = [max, min];
  }
  return value > min && value < max;
};
function CalendarRange(originalProps) {
  const props = withDefault(originalProps, {
    defaultValue: new Date(),
    type: "date"
  });
  const prefixClass = usePrefixClass();
  const defaultValues = computed(() => {
    let values = Array.isArray(props.defaultValue) ? props.defaultValue : [props.defaultValue, props.defaultValue];
    values = values.map((v) => startOfDay(v));
    if (isValidRangeDate(values)) {
      return values;
    }
    return [new Date(), new Date()].map((v) => startOfDay(v));
  });
  const innerValue = ref([new Date(NaN), new Date(NaN)]);
  watchEffect(() => {
    if (isValidRangeDate(props.value)) {
      innerValue.value = props.value;
    }
  });
  const handlePick = (date, type) => {
    var _a;
    const [startValue, endValue] = innerValue.value;
    if (isValidDate(startValue) && !isValidDate(endValue)) {
      if (startValue.getTime() > date.getTime()) {
        innerValue.value = [date, startValue];
      } else {
        innerValue.value = [startValue, date];
      }
      (_a = props["onUpdate:value"]) == null ? void 0 : _a.call(props, innerValue.value, type);
    } else {
      innerValue.value = [date, new Date(NaN)];
    }
  };
  const defaultCalendars = ref([new Date(), new Date()]);
  const calendars = computed(() => {
    return isValidRangeDate(props.calendar) ? props.calendar : defaultCalendars.value;
  });
  const calendarMinDiff = computed(() => {
    if (props.type === "year")
      return 10 * 12;
    if (props.type === "month")
      return 1 * 12;
    return 1;
  });
  const updateCalendars = (dates, index2) => {
    var _a;
    const diff = diffCalendarMonths(dates[0], dates[1]);
    const gap = calendarMinDiff.value - diff;
    if (gap > 0) {
      const anotherIndex = index2 === 1 ? 0 : 1;
      dates[anotherIndex] = setMonth(dates[anotherIndex], (v) => v + (anotherIndex === 0 ? -gap : gap));
    }
    defaultCalendars.value = dates;
    (_a = props.onCalendarChange) == null ? void 0 : _a.call(props, dates, index2);
  };
  const updateCalendarStart = (date) => {
    updateCalendars([date, calendars.value[1]], 0);
  };
  const updateCalendarEnd = (date) => {
    updateCalendars([calendars.value[0], date], 1);
  };
  watchEffect(() => {
    const dates = isValidRangeDate(props.value) ? props.value : defaultValues.value;
    updateCalendars(dates.slice(0, 2));
  });
  const hoveredValue = ref(null);
  const handleMouseEnter = (v) => hoveredValue.value = v;
  const handleMouseLeave = () => hoveredValue.value = null;
  const getRangeClasses = (cellDate, currentDates, classnames) => {
    const outerClasses = props.getClasses ? props.getClasses(cellDate, currentDates, classnames) : [];
    const classes = Array.isArray(outerClasses) ? outerClasses : [outerClasses];
    if (/disabled|active/.test(classnames))
      return classes;
    if (currentDates.length === 2 && inRange(cellDate, currentDates)) {
      classes.push("in-range");
    }
    if (currentDates.length === 1 && hoveredValue.value && inRange(cellDate, [currentDates[0], hoveredValue.value])) {
      return classes.concat("hover-in-range");
    }
    return classes;
  };
  return () => {
    const calendarRange = calendars.value.map((calendar, index2) => {
      const calendarProps2 = __spreadProps(__spreadValues({}, props), {
        calendar,
        value: innerValue.value,
        defaultValue: defaultValues.value[index2],
        getClasses: getRangeClasses,
        partialUpdate: false,
        multiple: false,
        ["onUpdate:value"]: handlePick,
        onCalendarChange: index2 === 0 ? updateCalendarStart : updateCalendarEnd,
        onDateMouseLeave: handleMouseLeave,
        onDateMouseEnter: handleMouseEnter
      });
      return createVNode(Calendar$1, calendarProps2, null);
    });
    return createVNode("div", {
      "class": `${prefixClass}-calendar-range`
    }, [calendarRange]);
  };
}
const calendarRangeProps = calendarProps;
var CalendarRange$1 = defineVueComponent(CalendarRange, calendarRangeProps);
const ScrollbarVertical = defineComponent({
  setup(props, {
    slots
  }) {
    const prefixClass = usePrefixClass();
    const wrapper = ref();
    const thumbHeight = ref("");
    const thumbTop = ref("");
    const getThumbHeight = () => {
      if (!wrapper.value)
        return;
      const el = wrapper.value;
      const heightPercentage = el.clientHeight * 100 / el.scrollHeight;
      thumbHeight.value = heightPercentage < 100 ? `${heightPercentage}%` : "";
    };
    onMounted(getThumbHeight);
    const scrollbarWidth = getScrollbarWidth();
    const handleScroll = (evt) => {
      const el = evt.currentTarget;
      const {
        scrollHeight,
        scrollTop
      } = el;
      thumbTop.value = `${scrollTop * 100 / scrollHeight}%`;
    };
    let draggable = false;
    let prevY = 0;
    const handleDragstart = (evt) => {
      evt.stopImmediatePropagation();
      const el = evt.currentTarget;
      const {
        offsetTop
      } = el;
      draggable = true;
      prevY = evt.clientY - offsetTop;
    };
    const handleDraging = (evt) => {
      if (!draggable || !wrapper.value)
        return;
      const {
        clientY
      } = evt;
      const {
        scrollHeight,
        clientHeight
      } = wrapper.value;
      const offsetY = clientY - prevY;
      const top = offsetY * scrollHeight / clientHeight;
      wrapper.value.scrollTop = top;
    };
    const handleDragend = () => {
      draggable = false;
    };
    onMounted(() => {
      document.addEventListener("mousemove", handleDraging);
      document.addEventListener("mouseup", handleDragend);
    });
    onUnmounted(() => {
      document.addEventListener("mousemove", handleDraging);
      document.addEventListener("mouseup", handleDragend);
    });
    return () => {
      var _a;
      return createVNode("div", {
        "class": `${prefixClass}-scrollbar`,
        "style": {
          position: "relative",
          overflow: "hidden"
        }
      }, [createVNode("div", {
        "ref": wrapper,
        "class": `${prefixClass}-scrollbar-wrap`,
        "style": {
          marginRight: `-${scrollbarWidth}px`
        },
        "onScroll": handleScroll
      }, [(_a = slots.default) == null ? void 0 : _a.call(slots)]), createVNode("div", {
        "class": `${prefixClass}-scrollbar-track`
      }, [createVNode("div", {
        "class": `${prefixClass}-scrollbar-thumb`,
        "style": {
          height: thumbHeight.value,
          top: thumbTop.value
        },
        "onMousedown": handleDragstart
      }, null)])]);
    };
  }
});
function Columns({
  options,
  getClasses,
  onSelect
}) {
  const prefixClass = usePrefixClass();
  const handleSelect = (evt) => {
    const target = evt.target;
    const currentTarget = evt.currentTarget;
    if (target.tagName.toUpperCase() !== "LI")
      return;
    const type = currentTarget.getAttribute("data-type");
    const col = parseInt(currentTarget.getAttribute("data-index"), 10);
    const index2 = parseInt(target.getAttribute("data-index"), 10);
    const value = options[col].list[index2].value;
    onSelect(value, type);
  };
  return createVNode("div", {
    "class": `${prefixClass}-time-columns`
  }, [options.map((col, i) => createVNode(ScrollbarVertical, {
    "key": col.type,
    "class": `${prefixClass}-time-column`
  }, {
    default: () => [createVNode("ul", {
      "class": `${prefixClass}-time-list`,
      "data-index": i,
      "data-type": col.type,
      "onClick": handleSelect
    }, [col.list.map((item, j) => createVNode("li", {
      "key": item.text,
      "data-index": j,
      "class": [`${prefixClass}-time-item`, getClasses(item.value, col.type)]
    }, [item.text]))])]
  }))]);
}
function _isSlot(s2) {
  return typeof s2 === "function" || Object.prototype.toString.call(s2) === "[object Object]" && !isVNode(s2);
}
function FixedList(props) {
  let _slot;
  const prefixClass = usePrefixClass();
  return createVNode(ScrollbarVertical, null, _isSlot(_slot = props.options.map((item) => createVNode("div", {
    "key": item.text,
    "class": [`${prefixClass}-time-option`, props.getClasses(item.value, "time")],
    "onClick": () => props.onSelect(item.value, "time")
  }, [item.text]))) ? _slot : {
    default: () => [_slot]
  });
}
function generateList({
  length,
  step = 1,
  options
}) {
  if (Array.isArray(options)) {
    return options.filter((v) => v >= 0 && v < length);
  }
  if (step <= 0) {
    step = 1;
  }
  const arr = [];
  for (let i = 0; i < length; i += step) {
    arr.push(i);
  }
  return arr;
}
function getColumnOptions(date, options) {
  let { showHour, showMinute, showSecond, use12h } = options;
  const format2 = options.format || "HH:mm:ss";
  showHour = typeof showHour === "boolean" ? showHour : /[HhKk]/.test(format2);
  showMinute = typeof showMinute === "boolean" ? showMinute : /m/.test(format2);
  showSecond = typeof showSecond === "boolean" ? showSecond : /s/.test(format2);
  use12h = typeof use12h === "boolean" ? use12h : /a/i.test(format2);
  const columns = [];
  const isPM = use12h && date.getHours() >= 12;
  if (showHour) {
    columns.push({
      type: "hour",
      list: generateList({
        length: use12h ? 12 : 24,
        step: options.hourStep,
        options: options.hourOptions
      }).map((num) => {
        const text = num === 0 && use12h ? "12" : padNumber(num);
        const value = new Date(date);
        value.setHours(isPM ? num + 12 : num);
        return { value, text };
      })
    });
  }
  if (showMinute) {
    columns.push({
      type: "minute",
      list: generateList({
        length: 60,
        step: options.minuteStep,
        options: options.minuteOptions
      }).map((num) => {
        const value = new Date(date);
        value.setMinutes(num);
        return { value, text: padNumber(num) };
      })
    });
  }
  if (showSecond) {
    columns.push({
      type: "second",
      list: generateList({
        length: 60,
        step: options.secondStep,
        options: options.secondOptions
      }).map((num) => {
        const value = new Date(date);
        value.setSeconds(num);
        return { value, text: padNumber(num) };
      })
    });
  }
  if (use12h) {
    columns.push({
      type: "ampm",
      list: ["AM", "PM"].map((text, i) => {
        const value = new Date(date);
        value.setHours(value.getHours() % 12 + i * 12);
        return { text, value };
      })
    });
  }
  return columns;
}
function parseOption(time = "") {
  const values = time.split(":");
  if (values.length >= 2) {
    const hours = parseInt(values[0], 10);
    const minutes = parseInt(values[1], 10);
    return {
      hours,
      minutes
    };
  }
  return null;
}
function getFixedOptions({
  date,
  option,
  format: format2,
  formatDate
}) {
  const result = [];
  if (typeof option === "function") {
    return option() || [];
  }
  const start = parseOption(option.start);
  const end = parseOption(option.end);
  const step = parseOption(option.step);
  const fmt = option.format || format2;
  if (start && end && step) {
    const startMinutes = start.minutes + start.hours * 60;
    const endMinutes = end.minutes + end.hours * 60;
    const stepMinutes = step.minutes + step.hours * 60;
    const len = Math.floor((endMinutes - startMinutes) / stepMinutes);
    for (let i = 0; i <= len; i++) {
      const timeMinutes = startMinutes + i * stepMinutes;
      const hours = Math.floor(timeMinutes / 60);
      const minutes = timeMinutes % 60;
      const value = new Date(date);
      value.setHours(hours, minutes, 0);
      result.push({
        value,
        text: formatDate(value, fmt)
      });
    }
  }
  return result;
}
const scrollTo = (element, to, duration = 0) => {
  if (duration <= 0) {
    requestAnimationFrame(() => {
      element.scrollTop = to;
    });
    return;
  }
  const difference = to - element.scrollTop;
  const tick = difference / duration * 10;
  requestAnimationFrame(() => {
    const scrollTop = element.scrollTop + tick;
    if (scrollTop >= to) {
      element.scrollTop = to;
      return;
    }
    element.scrollTop = scrollTop;
    scrollTo(element, to, duration - 10);
  });
};
function TimePanel(originalProps) {
  const props = withDefault(originalProps, {
    defaultValue: startOfDay(new Date()),
    format: "HH:mm:ss",
    timeTitleFormat: "YYYY-MM-DD",
    disabledTime: () => false,
    scrollDuration: 100
  });
  const prefixClass = usePrefixClass();
  const locale2 = useLocale();
  const formatDate = (date, fmt) => {
    return format(date, fmt, {
      locale: locale2.value.formatLocale
    });
  };
  const innerValue = ref(new Date());
  watchEffect(() => {
    innerValue.value = getValidDate(props.value, props.defaultValue);
  });
  const isDisabledTimes = (value) => {
    if (Array.isArray(value)) {
      return value.every((v) => props.disabledTime(new Date(v)));
    }
    return props.disabledTime(new Date(value));
  };
  const isDisabledHour = (date) => {
    const value = new Date(date);
    return isDisabledTimes([value.getTime(), value.setMinutes(0, 0, 0), value.setMinutes(59, 59, 999)]);
  };
  const isDisabledMinute = (date) => {
    const value = new Date(date);
    return isDisabledTimes([value.getTime(), value.setSeconds(0, 0), value.setSeconds(59, 999)]);
  };
  const isDisabledAMPM = (date) => {
    const value = new Date(date);
    const minHour = value.getHours() < 12 ? 0 : 12;
    const maxHour = minHour + 11;
    return isDisabledTimes([value.getTime(), value.setHours(minHour, 0, 0, 0), value.setHours(maxHour, 59, 59, 999)]);
  };
  const isDisabled = (date, type) => {
    if (type === "hour") {
      return isDisabledHour(date);
    }
    if (type === "minute") {
      return isDisabledMinute(date);
    }
    if (type === "ampm") {
      return isDisabledAMPM(date);
    }
    return isDisabledTimes(date);
  };
  const handleSelect = (value, type) => {
    var _a;
    if (!isDisabled(value, type)) {
      const date = new Date(value);
      innerValue.value = date;
      if (!isDisabledTimes(date)) {
        (_a = props["onUpdate:value"]) == null ? void 0 : _a.call(props, date, type);
      }
    }
  };
  const getClasses = (cellDate, type) => {
    if (isDisabled(cellDate, type)) {
      return "disabled";
    }
    if (cellDate.getTime() === innerValue.value.getTime()) {
      return "active";
    }
    return "";
  };
  const container = ref();
  const scrollToSelected = (duration) => {
    if (!container.value)
      return;
    const elements = container.value.querySelectorAll(".active");
    for (let i = 0; i < elements.length; i++) {
      const element = elements[i];
      const scrollElement = getScrollParent(element, container.value);
      if (scrollElement) {
        const to = element.offsetTop;
        scrollTo(scrollElement, to, duration);
      }
    }
  };
  onMounted(() => scrollToSelected(0));
  watch(innerValue, () => scrollToSelected(props.scrollDuration), {
    flush: "post"
  });
  return () => {
    let content;
    if (props.timePickerOptions) {
      content = createVNode(FixedList, {
        "onSelect": handleSelect,
        "getClasses": getClasses,
        "options": getFixedOptions({
          date: innerValue.value,
          format: props.format,
          option: props.timePickerOptions,
          formatDate
        })
      }, null);
    } else {
      content = createVNode(Columns, {
        "options": getColumnOptions(innerValue.value, props),
        "onSelect": handleSelect,
        "getClasses": getClasses
      }, null);
    }
    return createVNode("div", {
      "class": `${prefixClass}-time`,
      "ref": container
    }, [props.showTimeHeader && createVNode("div", {
      "class": `${prefixClass}-time-header`
    }, [createVNode("button", {
      "type": "button",
      "class": `${prefixClass}-btn ${prefixClass}-btn-text ${prefixClass}-time-header-title`,
      "onClick": props.onClickTitle
    }, [formatDate(innerValue.value, props.timeTitleFormat)])]), createVNode("div", {
      "class": `${prefixClass}-time-content`
    }, [content])]);
  };
}
const timePanelProps = keys()(["value", "defaultValue", "format", "timeTitleFormat", "showTimeHeader", "disabledTime", "timePickerOptions", "hourOptions", "minuteOptions", "secondOptions", "hourStep", "minuteStep", "secondStep", "showHour", "showMinute", "showSecond", "use12h", "scrollDuration", "onClickTitle", "onUpdate:value"]);
var TimePanel$1 = defineVueComponent(TimePanel, timePanelProps);
function TimeRange(originalProps) {
  const props = withDefault(originalProps, {
    defaultValue: startOfDay(new Date()),
    disabledTime: () => false
  });
  const prefixClass = usePrefixClass();
  const innerValue = ref([new Date(NaN), new Date(NaN)]);
  watchEffect(() => {
    if (isValidRangeDate(props.value)) {
      innerValue.value = props.value;
    } else {
      innerValue.value = [new Date(NaN), new Date(NaN)];
    }
  });
  const emitChange = (type, index2) => {
    var _a;
    (_a = props["onUpdate:value"]) == null ? void 0 : _a.call(props, innerValue.value, type === "time" ? "time-range" : type, index2);
  };
  const handleSelectStart = (date, type) => {
    innerValue.value[0] = date;
    if (!(innerValue.value[1].getTime() >= date.getTime())) {
      innerValue.value[1] = date;
    }
    emitChange(type, 0);
  };
  const handleSelectEnd = (date, type) => {
    innerValue.value[1] = date;
    if (!(innerValue.value[0].getTime() <= date.getTime())) {
      innerValue.value[0] = date;
    }
    emitChange(type, 1);
  };
  const disabledStartTime = (date) => {
    return props.disabledTime(date, 0);
  };
  const disabledEndTime = (date) => {
    return date.getTime() < innerValue.value[0].getTime() || props.disabledTime(date, 1);
  };
  return () => {
    const defaultValues = Array.isArray(props.defaultValue) ? props.defaultValue : [props.defaultValue, props.defaultValue];
    return createVNode("div", {
      "class": `${prefixClass}-time-range`
    }, [createVNode(TimePanel$1, __spreadProps(__spreadValues({}, props), {
      ["onUpdate:value"]: handleSelectStart,
      "value": innerValue.value[0],
      "defaultValue": defaultValues[0],
      "disabledTime": disabledStartTime
    }), null), createVNode(TimePanel$1, __spreadProps(__spreadValues({}, props), {
      ["onUpdate:value"]: handleSelectEnd,
      "value": innerValue.value[1],
      "defaultValue": defaultValues[1],
      "disabledTime": disabledEndTime
    }), null)]);
  };
}
const timeRangeProps = timePanelProps;
var TimeRange$1 = defineVueComponent(TimeRange, timeRangeProps);
function useTimePanelVisible(props) {
  const defaultTimeVisible = ref(false);
  const closeTimePanel = () => {
    var _a;
    defaultTimeVisible.value = false;
    (_a = props.onShowTimePanelChange) == null ? void 0 : _a.call(props, false);
  };
  const openTimePanel = () => {
    var _a;
    defaultTimeVisible.value = true;
    (_a = props.onShowTimePanelChange) == null ? void 0 : _a.call(props, true);
  };
  const timeVisible = computed(() => {
    return typeof props.showTimePanel === "boolean" ? props.showTimePanel : defaultTimeVisible.value;
  });
  return { timeVisible, openTimePanel, closeTimePanel };
}
function DateTime(originalProps) {
  const props = withDefault(originalProps, {
    disabledTime: () => false,
    defaultValue: startOfDay(new Date())
  });
  const currentValue = ref(props.value);
  watchEffect(() => {
    currentValue.value = props.value;
  });
  const {
    openTimePanel,
    closeTimePanel,
    timeVisible
  } = useTimePanelVisible(props);
  const handleSelect = (date, type) => {
    var _a;
    if (type === "date") {
      openTimePanel();
    }
    let datetime = assignTime(date, getValidDate(props.value, props.defaultValue));
    if (props.disabledTime(new Date(datetime))) {
      datetime = assignTime(date, props.defaultValue);
      if (props.disabledTime(new Date(datetime))) {
        currentValue.value = datetime;
        return;
      }
    }
    (_a = props["onUpdate:value"]) == null ? void 0 : _a.call(props, datetime, type);
  };
  return () => {
    const prefixClass = usePrefixClass();
    const calendarProp = __spreadProps(__spreadValues({}, pick(props, calendarProps)), {
      multiple: false,
      type: "date",
      value: currentValue.value,
      ["onUpdate:value"]: handleSelect
    });
    const timeProps = __spreadProps(__spreadValues({}, pick(props, timePanelProps)), {
      showTimeHeader: true,
      value: currentValue.value,
      ["onUpdate:value"]: props["onUpdate:value"],
      onClickTitle: closeTimePanel
    });
    return createVNode("div", {
      "class": `${prefixClass}-date-time`
    }, [createVNode(Calendar$1, calendarProp, null), timeVisible.value && createVNode(TimePanel$1, timeProps, null)]);
  };
}
const datetimeBaseProps = keys()(["showTimePanel", "onShowTimePanelChange"]);
const datetimeProps = [...datetimeBaseProps, ...calendarProps, ...timePanelProps];
var DateTime$1 = defineVueComponent(DateTime, datetimeProps);
function DateTimeRange(originalProps) {
  const props = withDefault(originalProps, {
    defaultValue: startOfDay(new Date()),
    disabledTime: () => false
  });
  const currentValue = ref(props.value);
  watchEffect(() => {
    currentValue.value = props.value;
  });
  const {
    openTimePanel,
    closeTimePanel,
    timeVisible
  } = useTimePanelVisible(props);
  const handleSelect = (dates, type) => {
    var _a;
    if (type === "date") {
      openTimePanel();
    }
    const defaultValues = Array.isArray(props.defaultValue) ? props.defaultValue : [props.defaultValue, props.defaultValue];
    let datetimes = dates.map((date, i) => {
      const time = isValidRangeDate(props.value) ? props.value[i] : defaultValues[i];
      return assignTime(date, time);
    });
    if (datetimes[1].getTime() < datetimes[0].getTime()) {
      datetimes = [datetimes[0], datetimes[0]];
    }
    if (datetimes.some(props.disabledTime)) {
      datetimes = dates.map((date, i) => assignTime(date, defaultValues[i]));
      if (datetimes.some(props.disabledTime)) {
        currentValue.value = datetimes;
        return;
      }
    }
    (_a = props["onUpdate:value"]) == null ? void 0 : _a.call(props, datetimes, type);
  };
  return () => {
    const prefixClass = usePrefixClass();
    const calendarProp = __spreadProps(__spreadValues({}, pick(props, calendarRangeProps)), {
      type: "date",
      value: currentValue.value,
      ["onUpdate:value"]: handleSelect
    });
    const timeProps = __spreadProps(__spreadValues({}, pick(props, timeRangeProps)), {
      showTimeHeader: true,
      value: currentValue.value,
      ["onUpdate:value"]: props["onUpdate:value"],
      onClickTitle: closeTimePanel
    });
    return createVNode("div", {
      "class": `${prefixClass}-date-time-range`
    }, [createVNode(CalendarRange$1, calendarProp, null), timeVisible.value && createVNode(TimeRange$1, timeProps, null)]);
  };
}
const datetimeRangeProps = [...datetimeBaseProps, ...timeRangeProps, ...calendarRangeProps];
var DateTimeRange$1 = defineVueComponent(DateTimeRange, datetimeRangeProps);
const booleanKeys = keys()(["range", "open", "appendToBody", "clearable", "confirm", "disabled", "editable", "multiple", "partialUpdate", "showHour", "showMinute", "showSecond", "showTimeHeader", "showTimePanel", "showWeekNumber", "use12h"]);
const formatMap = {
  date: "YYYY-MM-DD",
  datetime: "YYYY-MM-DD HH:mm:ss",
  year: "YYYY",
  month: "YYYY-MM",
  time: "HH:mm:ss",
  week: "w"
};
function DatePicker(originalProps, {
  slots
}) {
  const type = originalProps.type || "date";
  const format2 = originalProps.format || formatMap[type] || formatMap.date;
  const props = __spreadProps(__spreadValues({}, resolveProps(originalProps, booleanKeys)), {
    type,
    format: format2
  });
  return createVNode(Picker$1, pick(props, Picker$1.props), __spreadValues({
    content: (slotProps) => {
      if (props.range) {
        const Content = type === "time" ? TimeRange$1 : type === "datetime" ? DateTimeRange$1 : CalendarRange$1;
        return h(Content, pick(__spreadValues(__spreadValues({}, props), slotProps), Content.props));
      } else {
        const Content = type === "time" ? TimePanel$1 : type === "datetime" ? DateTime$1 : Calendar$1;
        return h(Content, pick(__spreadValues(__spreadValues({}, props), slotProps), Content.props));
      }
    },
    ["icon-calendar"]: () => type === "time" ? createVNode(render, null, null) : createVNode(render$2, null, null)
  }, slots));
}
const api = {
  locale,
  install: (app) => {
    app.component("DatePicker", DatePicker);
  }
};
var index = Object.assign(DatePicker, api, {
  Calendar: Calendar$1,
  CalendarRange: CalendarRange$1,
  TimePanel: TimePanel$1,
  TimeRange: TimeRange$1,
  DateTime: DateTime$1,
  DateTimeRange: DateTimeRange$1
});
var DateField_vue_vue_type_style_index_0_lang = "";
const _hoisted_1$3 = { class: "tuxedo-input-field-group" };
const _hoisted_2$3 = ["for"];
const _hoisted_3$3 = {
  key: 1,
  class: "form-text text-danger"
};
const _hoisted_4$3 = {
  key: 2,
  class: "form-text text-muted"
};
const _sfc_main$3 = {
  __name: "DateField",
  props: {
    label: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    type: {
      type: String,
      required: false,
      default() {
        return "date";
      }
    },
    help: {
      type: String,
      required: false
    },
    error: {
      type: Object,
      required: false
    },
    modelValue: {
      type: [String, Number],
      required: false
    },
    insistFormat: {
      type: String,
      required: false
    },
    format: {
      type: String,
      required: false
    },
    minuteStep: {
      type: Number,
      required: false,
      default() {
        return 15;
      }
    },
    disabledDates: {
      type: Object,
      required: false,
      default() {
        return {};
      }
    },
    shortcuts: {
      type: Array,
      required: false,
      default() {
        return [
          {
            text: "Today",
            onClick() {
              return new Date();
            }
          }
        ];
      }
    },
    range: {
      type: Boolean,
      required: false
    },
    inputClass: {
      type: String,
      required: false
    }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    const displayFormat = computed(() => {
      if (props.format)
        return props.format;
      if (props.type === "datetime")
        return "ddd MMM D, YYYY h:mma";
      return "ddd MMM D, YYYY";
    });
    const handleFormat = (dateObject, format2) => {
      if (format2 === "iso") {
        return dateObject.toISOString();
      } else if (format2 === "isoDate") {
        let ye = new Intl.DateTimeFormat("en", { year: "numeric" }).format(dateObject);
        let mo = new Intl.DateTimeFormat("en", { month: "2-digit" }).format(dateObject);
        let da = new Intl.DateTimeFormat("en", { day: "2-digit" }).format(dateObject);
        return `${ye}-${mo}-${da}`;
      } else if (format2 === "isoDateTime") {
        let ye = new Intl.DateTimeFormat("en", { year: "numeric" }).format(dateObject);
        let mo = new Intl.DateTimeFormat("en", { month: "2-digit" }).format(dateObject);
        let da = new Intl.DateTimeFormat("en", { day: "2-digit" }).format(dateObject);
        let time = new Intl.DateTimeFormat("en", { hour: "2-digit", hour12: false, minute: "2-digit" }).format(dateObject);
        return `${ye}-${mo}-${da}T${time}`;
      }
    };
    const clear = () => {
      emit("clear");
    };
    const inputValue = computed({
      get() {
        if (props.range) {
          let value1 = new Date();
          let value2 = new Date();
          if (Array.isArray(props.modelValue)) {
            value1 = Date.parse(props.modelValue[0]);
            value1 = new Date(value1);
            value2 = Date.parse(props.modelValue[1]);
            value2 = new Date(value2);
          }
          return [value1, value2];
        } else if (props.modelValue) {
          const value = Date.parse(props.modelValue);
          return new Date(value);
        }
        return null;
      },
      set(val) {
        if (val && props.insistFormat && props.range) {
          val = [
            handleFormat(val[0], props.insistFormat),
            handleFormat(val[1], props.insistFormat)
          ];
        } else if (val && props.insistFormat) {
          val = handleFormat(val, props.insistFormat);
        }
        emit("update:modelValue", val);
      }
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$3, [
        __props.label ? (openBlock(), createElementBlock("label", {
          key: 0,
          for: __props.name,
          class: "text-uppercase mb-0"
        }, toDisplayString(__props.label), 9, _hoisted_2$3)) : createCommentVNode("", true),
        createVNode(unref(index), {
          class: "tuxedo-date",
          type: __props.type,
          format: unref(displayFormat),
          "disabled-dates": __props.disabledDates,
          "minute-step": __props.minuteStep,
          shortcuts: __props.shortcuts,
          onClosed: _cache[0] || (_cache[0] = ($event) => _ctx.$emit("closed")),
          onClear: clear,
          range: __props.range,
          "input-class": __props.inputClass,
          value: unref(inputValue),
          "onUpdate:value": _cache[1] || (_cache[1] = ($event) => isRef(inputValue) ? inputValue.value = $event : null)
        }, null, 8, ["type", "format", "disabled-dates", "minute-step", "shortcuts", "range", "input-class", "value"]),
        __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_3$3, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_4$3, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
      ]);
    };
  }
};
var TimeField_vue_vue_type_style_index_0_lang = "";
const _hoisted_1$2 = { class: "tuxedo-input-field-group" };
const _hoisted_2$2 = ["for"];
const _hoisted_3$2 = {
  key: 1,
  class: "form-text text-danger"
};
const _hoisted_4$2 = {
  key: 2,
  class: "form-text text-muted"
};
const _sfc_main$2 = {
  __name: "TimeField",
  props: {
    label: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    type: {
      type: String,
      required: false,
      default() {
        return "date";
      }
    },
    help: {
      type: String,
      required: false
    },
    error: {
      type: Object,
      required: false
    },
    modelValue: {
      type: [String, Number],
      required: false
    },
    insistFormat: {
      type: String,
      required: false,
      default() {
        return "24";
      }
    },
    format: {
      type: String,
      required: false,
      default() {
        return "h:mma";
      }
    },
    minuteStep: {
      type: Number,
      required: false,
      default() {
        return 1;
      }
    },
    disabledDates: {
      type: Object,
      required: false,
      default() {
        return {};
      }
    },
    shortcuts: {
      type: Array,
      required: false,
      default() {
        return [
          {
            text: "Now",
            onClick() {
              return new Date();
            }
          }
        ];
      }
    },
    range: {
      type: Boolean,
      required: false
    },
    inputClass: {
      type: String,
      required: false
    }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    const handleFormat = (dateObject, format2) => {
      if (format2 === "24") {
        let time = new Intl.DateTimeFormat("en", { hour: "2-digit", hour12: false, minute: "2-digit" }).format(dateObject);
        return `${time}`;
      } else if (format2 === "iso") {
        return dateObject.toISOString();
      }
    };
    const inputValue = computed({
      get() {
        if (props.range) {
          let value1 = new Date();
          let value2 = new Date();
          if (Array.isArray(props.modelValue)) {
            let time1 = props.modelValue[0].split(":");
            let time2 = props.modelValue[1].split(":");
            value1.setHours(time1[0]);
            value1.setMinutes(time1[1]);
            value2.setHours(time2[0]);
            value2.setMinutes(time2[1]);
          }
          return [value1, value2];
        } else if (props.insistFormat === "iso") {
          const value = Date.parse(props.modelValue);
          return new Date(value);
        } else {
          let time = props.modelValue ? props.modelValue.split(":") : [0, 0];
          const value = new Date();
          value.setHours(time[0]);
          value.setMinutes(time[1]);
          return value;
        }
      },
      set(val) {
        if (props.insistFormat && props.range) {
          val = [
            handleFormat(val[0], props.insistFormat),
            handleFormat(val[1], props.insistFormat)
          ];
        } else if (props.insistFormat) {
          val = handleFormat(val, props.insistFormat);
        }
        emit("update:modelValue", val);
      }
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$2, [
        __props.label ? (openBlock(), createElementBlock("label", {
          key: 0,
          for: __props.name,
          class: "text-uppercase mb-0"
        }, toDisplayString(__props.label), 9, _hoisted_2$2)) : createCommentVNode("", true),
        createVNode(unref(index), {
          class: "tuxedo-date",
          type: "time",
          format: __props.format,
          "minute-step": __props.minuteStep,
          shortcuts: __props.shortcuts,
          onClosed: _cache[0] || (_cache[0] = ($event) => _ctx.$emit("closed")),
          range: __props.range,
          "input-class": __props.inputClass,
          value: unref(inputValue),
          "onUpdate:value": _cache[1] || (_cache[1] = ($event) => isRef(inputValue) ? inputValue.value = $event : null)
        }, null, 8, ["format", "minute-step", "shortcuts", "range", "input-class", "value"]),
        __props.error && __props.error[__props.name] ? (openBlock(), createElementBlock("small", _hoisted_3$2, toDisplayString(__props.error[__props.name][0]), 1)) : __props.help ? (openBlock(), createElementBlock("small", _hoisted_4$2, toDisplayString(__props.help), 1)) : createCommentVNode("", true)
      ]);
    };
  }
};
const _sfc_main$1 = {
  name: "ToggleField",
  props: {
    label: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: true
    },
    help: {
      type: String,
      required: false
    },
    value: {
      type: String | Number,
      required: false
    },
    error: {
      type: Object,
      required: false
    }
  },
  methods: {
    checked(checked) {
      this.$emit("input", checked ? 1 : 0);
    }
  }
};
const _hoisted_1$1 = { class: "custom-control custom-switch" };
const _hoisted_2$1 = ["id", "checked"];
const _hoisted_3$1 = ["for"];
const _hoisted_4$1 = {
  key: 0,
  class: "form-text text-danger"
};
const _hoisted_5$1 = {
  key: 1,
  class: "form-text text-muted"
};
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, [
    createElementVNode("div", _hoisted_1$1, [
      createElementVNode("input", {
        type: "checkbox",
        class: "custom-control-input",
        id: $props.name,
        checked: $props.value,
        onChange: _cache[0] || (_cache[0] = ($event) => $options.checked($event.target.checked))
      }, null, 40, _hoisted_2$1),
      createElementVNode("label", {
        class: "custom-control-label",
        for: $props.name
      }, toDisplayString($props.label), 9, _hoisted_3$1)
    ]),
    $props.error && $props.error[$props.name] ? (openBlock(), createElementBlock("small", _hoisted_4$1, toDisplayString($props.error[$props.name][0]), 1)) : $props.help ? (openBlock(), createElementBlock("small", _hoisted_5$1, toDisplayString($props.help), 1)) : createCommentVNode("", true)
  ]);
}
var ToggleField = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
const _sfc_main = {
  name: "SecondaryMenu",
  directives: {
    clickOutside: vClickOutside.directive
  },
  props: {
    target: {
      type: String
    },
    breakpoint: {
      type: Number,
      default() {
        return 768;
      }
    }
  },
  data() {
    return {
      maxHeight: 0,
      optionsHeight: 0
    };
  },
  computed: {
    el() {
      if (this.target) {
        const el = document.getElementById(this.target);
        if (el)
          return el.getBoundingClientRect();
      }
      return null;
    },
    pixelsTop() {
      if (this.el) {
        const { top } = this.el;
        return top;
      }
      return 1;
    },
    pixelsBottom() {
      if (this.el) {
        const { top, height } = this.el;
        return window.innerHeight - (top + height);
      }
      return 1;
    },
    pixelsLeft() {
      if (this.el) {
        const { left } = this.el;
        return left;
      }
      return 1;
    },
    pixelsRight() {
      if (this.el) {
        const { left, width } = this.el;
        return window.innerWidth - (left + width);
      }
      return 1;
    },
    optionsWidth() {
      return this.$refs.menu.clientWidth;
    },
    x() {
      if (this.el) {
        if (this.pixelsLeft > this.optionsWidth) {
          const { left } = this.el;
          return left - this.optionsWidth;
        } else if (this.pixelsRight > this.optionsWidth) {
          const { right } = this.el;
          return right;
        }
      }
    },
    y() {
      if (this.el) {
        if (this.pixelsTop > this.optionsHeight) {
          const { bottom } = this.el;
          return bottom - this.optionsHeight;
        } else if (this.pixelsBottom > this.optionsHeight) {
          const { top } = this.el;
          return top;
        }
      }
    }
  },
  methods: {
    closeSelector() {
      const body = document.getElementsByTagName("body");
      body[0].style.overflow = "initial";
      this.$emit("close");
    }
  },
  mounted() {
    setTimeout(() => {
      this.maxHeight = 70;
    }, 1);
    if (window.innerWidth < this.breakpoint) {
      const body = document.getElementsByTagName("body");
      body[0].style.overflow = "hidden";
    } else {
      setTimeout(() => {
        this.optionsHeight = this.$refs.menu.clientHeight;
        this.$refs.menu.style.left = this.x + "px";
        this.$refs.menu.style.top = this.y + "px";
      }, 2);
    }
  }
};
const _hoisted_1 = { class: "tuxedo-secondary-menu" };
const _hoisted_2 = {
  class: "tuxedo-secondary-menu-options",
  ref: "menu"
};
const _hoisted_3 = { class: "tuxedo-mobile-select-options" };
const _hoisted_4 = { class: "select-grow-1" };
const _hoisted_5 = /* @__PURE__ */ createElementVNode("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  fill: "currentColor",
  viewBox: "0 0 16 16"
}, [
  /* @__PURE__ */ createElementVNode("path", {
    "fill-rule": "evenodd",
    d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"
  })
], -1);
const _hoisted_6 = [
  _hoisted_5
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _directive_click_outside = resolveDirective("click-outside");
  return openBlock(), createElementBlock("div", _hoisted_1, [
    withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [
      createElementVNode("div", _hoisted_3, [
        createElementVNode("div", _hoisted_4, [
          createElementVNode("div", {
            class: "select-close-icon",
            onClick: _cache[0] || (_cache[0] = (...args) => $options.closeSelector && $options.closeSelector(...args))
          }, _hoisted_6)
        ])
      ]),
      createElementVNode("div", {
        class: "options",
        style: normalizeStyle("max-height:" + $data.maxHeight + "vh"),
        ref: "options"
      }, [
        renderSlot(_ctx.$slots, "default")
      ], 4)
    ])), [
      [_directive_click_outside, $options.closeSelector]
    ])
  ]);
}
var SecondaryMenu = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { _sfc_main$3 as TuxedoDate, _sfc_main$8 as TuxedoInput, _sfc_main$5 as TuxedoRadio, SecondaryMenu as TuxedoSecondaryMenu, ObjectSelectField as TuxedoSelect, _sfc_main$6 as TuxedoSwitch, _sfc_main$7 as TuxedoText, _sfc_main$2 as TuxedoTime, ToggleField as TuxedoToggle };
